/*
 * Created on Apr 15, 2005
 *
 * Michael L Brereton - www.ewesoft.com
 * 
 * 
 */
package eve.fx.gui;

/**
 * @author Michael L Brereton
 *
 */
//####################################################
public interface WindowConstants {

	public static final int STATE_NORMAL = 0x1;
	public static final int STATE_MAXIMIZED = 0x2;
	public static final int STATE_MINIMIZED = 0x3;
	public static final int STATE_FULL_SCREEN = 0x4;
	public static final int STATE_UNKNOWN = 0;
	/**
	 * This is used with setState() only. It is used to restore
	 * the window to its normal state.
	 */
	public static final int STATE_RESTORE = 0x8000;
	/**
	 * This flag is present on return from 
	 */
	//public static final int STATE_KNOWN = 0x8000;
	
	/**
	 * This is used with setState() only. It is used to bring the
	 * window to the front.
	 */
	public static final int STATE_TO_FRONT = 0x5;
	static final int STATE_ACCEPT_DROPPED_FILES = 0x10000;
	static final int STATE_REJECT_DROPPED_FILES = 0x20000;
	
	public static final int FLAG_HAS_CLOSE_BUTTON = 0x1;
	public static final int FLAG_IS_VISIBLE = 0x2;
	public static final int FLAG_IS_ICONIZED = 0x4;
	public static final int FLAG_HAS_TITLE = 0x8;
	public static final int FLAG_CAN_MAXIMIZE = 0x10;
	public static final int FLAG_CAN_MINIMIZE = 0x20;
	public static final int FLAG_CAN_RESIZE  = 0x40;
	public static final int FLAG_IS_MODAL = 0x80;
	public static final int FLAG_DONT_CLEAR_BACKGROUND = 0x100;
	public static final int FLAG_HAS_TASKBAR_ENTRY = 0x200;
	public static final int FLAG_SHOW_SIP_BUTTON = 0x400;
	public static final int FLAG_MAXIMIZE_ON_PDA = 0x800;
	public static final int FLAG_MAXIMIZE = 0x1000;
	public static final int FLAG_MINIMIZE = 0x2000;
	public static final int FLAG_FULL_SCREEN = 0x4000;
	public static final int FLAG_ALWAYS_ON_TOP = 0x10000;
	public static final int FLAG_VISIBLE_ON_TO_FRONT = 0x20000;
	public static final int FLAG_IS_DEFAULT_SURFACE = 0x40000;
	public static final int FLAG_IS_NOT_DEFAULT_SURFACE = 0x80000;
	public static final int FLAG_ACCEPTS_DROPPED_FILES = 0x800000;
	/**
	 * This flag indicates that other Modal windows do not stop this
	 * Window from getting events.
	 */
	public static final int FLAG_ALWAYS_ENABLED = 0x100000;
	public static final int FLAG_IS_DEFAULT_SIZE = 0x80000000;
	
	/**
	* Use this to get or set the window location
	* and size on the screen. When calling getInfo you must provide a Rect object
	* as the result destination. When calling setInfo you must provide a Rect object
	* as the sourceParameter.
	**/
	//public static final int INFO_WINDOW_RECT = 1;
	/**
	* Use this to get or set the window (i.e. native application window) flags. This
	* includes the FLAG_ values. When calling getInfo you must provide a Long object as
	* the result destination. When calling setInfo you must provide a Long object as the
	* sourceParameter.
	**/
	//public static final int INFO_WINDOW_FLAGS = 2;
	/**
	* Use this to get or set the parent's client screen rectangle. Only the width and height values
	* are relevant. When calling getInfo you must provide a Rect object
	* as the result destination.
	**/
	//public static final int INFO_PARENT_RECT = 3;
	/**
	* Use this to get the Rect of the client area, but the x and y co-ordinates will always be 0,0.
	**/
	//public static final int INFO_CLIENT_RECT = 4;
	/**
	* This is used to get the window flags for a particular size. 
	**/
	//public static final int INFO_FLAGS_FOR_SIZE = 5;
	/**
	* Use this to get or set the user's screen rectangle. When calling getInfo you must provide a Rect object
	* as the result destination. When calling setInfo you must provide a Rect object
	* as the sourceParameter.
	**/
	//public static final int INFO_SCREEN_RECT = 6;
	/**
	* Use this along with a Window.TaskBarIconInfo class to set the taskbar icon info for a window.
	**/
	//public static final int INFO_TASKBAR_ICON = 7;
	/**
	* Use this along with an Icon Object to set the window icon for a window.
	**/
	//public static final int INFO_WINDOW_ICON = 8;
	/**
	* This is a parameter for Window.getGuiInfo(), use it with a ewe.sys.Long object as the
	* destination parameters.
	**/
	//public static final int INFO_GUI_FLAGS = 9;
	/**
	* A GUI flag that indicates that
	* the OS supports placing icons in a taskbar.
	**/
	public static final int GUI_FLAG_HAS_TASKBAR = 0x1;
	/**
	* A GUI flag that indicates that
	* Cancel buttons should come before OK buttons.
	**/
	public static final int GUI_FLAG_REVERSE_OK_CANCEL = 0x2;
	public static final int GUI_FLAG_DONT_REPAINT_ON_RESIZE = 0x4;
	public static final int GUI_FLAG_REPAINT_FULL_CONTROL = 0x100;
	/**
	* This is a parameter for Window.setInfo(), Window.getInfo() use it with a ewe.sys.Long object as the
	* destination parameters.
	**/

	/**
	This tells the system that when creating the main window that it should
	be invisible, even on SmartPhone or other systems that only use a single
	window surface.
	**/
	/*
	#define GUI_FLAG_SOFTKEY_FORMAT 0x8
	#define GUI_FLAG_NO_VISIBLE_WINDOW 0x10

	#define GUI_FLAG_SIMULATE_POCKETPC 0x20

	#define GUI_FLAG_SIMULATE_SMARTPHONE 0x40
*/	
	//static final int INFO_TITLE = 10;
	//static final int INFO_DROPPED_DATA = 11;
	//static final int INFO_FONT = 12;
	/**
	* Use this with setInfo(INFO_WINDOW_FLAGS) to specify that the provided flags should be set.
	**/
	//public static final int OPTION_FLAG_SET = 0x1;
	/**
	* Use this with setInfo(INFO_WINDOW_FLAGS) to specify that the provided flags should be cleared.
	**/
	//public static final int OPTION_FLAG_CLEAR = 0x2;
	public static final int FLAG_FOR_SIZE_NO_TITLE = 0x1;
	public static final int FLAG_FOR_SIZE_NO_CLOSE_BUTTON = 0x2;
	
	public static final int SPECIAL_MOUSE_MOVE = 1;
	public static final int SPECIAL_MOUSE_RESIZE = 2;
	public static final int SPECIAL_MOUSE_RELEASE_CAPTURE = 3;
}
//####################################################
