package eve.ui;
import eve.sys.Convert;
/**
* An IntChoice is a Choice that treats setInt() and getInt() differently. Normally getInt()
* on an mChoice will return the chosen index. However getInt() on an IntChoice will convert
* the String at the chosen index to an integer value and return it. The same goes for setInt().
**/
//##################################################################
public class IntChoice extends Choice{
//##################################################################
{
	modify(PreferredSizeOnly,0);
}
//===================================================================
public static String [] intToStrings(int [] values)
//===================================================================
{
	String [] s = new String[values.length];
	for (int i = 0; i<s.length; i++) s[i] = Convert.toString(values[i]);
	return s;
}
//===================================================================
public IntChoice(int [] values,int initialValue)
//===================================================================
{
	this(intToStrings(values),0);
}
//===================================================================
public IntChoice(String [] values,int initialValue)
//===================================================================
{
	super(values,0);
	setInt(initialValue);
}
//===================================================================
public IntChoice(String values,int initialValue)
//===================================================================
{
	super(values,0);
	setInt(initialValue);
}
//===================================================================
public void setInt(int value) 
//===================================================================
{
	for (int i = 0; i<itemsSize(); i++){
		if (Convert.toInt(getItemAt(i).label) == value){
			select(i);
			return;
		}
	}
	select(-1);
}
/**
 * Return the integer value of the String at the currently selected index.
 */
//===================================================================
public int getInt() {return Convert.toInt(getText());}
//===================================================================

//##################################################################
}
//##################################################################

