package eve.ui;

/**
 * This is used to hold the specifications for the SIPKeypad.
 */
public class SIPKeypadKeys {

	public int keyCount;
	public int[] keys;
	public int[] mods;
	public short[] rects;
	public Object[] displays;

	public SIPKeypadKeys(int maxKeys)
	{
		if (maxKeys > 0){
			keys = new int[maxKeys];
			mods = new int[maxKeys];
			rects = new short[maxKeys*4];
			displays = new Object[maxKeys];
		}
	}
	
	public int addRow(int startKeyIndex, int numKeys, int startX, int startY,int keyWidth,int keyHeight)
	{
		short x = (short)startX, y = (short)startY;
		int idx = startKeyIndex*4;
		for (int i = 0; i<numKeys; i++){
			rects[idx] = x;
			rects[idx+1] = y;
			rects[idx+2] = (short)keyWidth;
			rects[idx+3] = (short)keyHeight;
			idx += 4;
			x += keyWidth-1;
		}
		return numKeys;
	}
	public int addColumn(int startKeyIndex, int numKeys, int startX, int startY,int keyWidth,int keyHeight)
	{
		short x = (short)startX, y = (short)startY;
		int idx = startKeyIndex*4;
		for (int i = 0; i<numKeys; i++){
			rects[idx] = x;
			rects[idx+1] = y;
			rects[idx+2] = (short)keyWidth;
			rects[idx+3] = (short)keyHeight;
			idx += 4;
			y += keyHeight-1;
		}
		return numKeys;
	}
	public int addSequence(int startKeyIndex, String chars)
	{
		int num = chars.length();
		for (int i = 0; i<num; i++){
			keys[startKeyIndex] = chars.charAt(i);
			mods[startKeyIndex] = 0;
			displays[startKeyIndex] = null;
			startKeyIndex++;
		}
		return num;
	}
	public int addRow(int startKeyIndex,String chars,int startX, int startY,int keyWidth,int keyHeight)
	{
		int did = addSequence(startKeyIndex,chars);
		return addRow(startKeyIndex,did,startX,startY,keyWidth,keyHeight);
	}
	public int addColumn(int startKeyIndex,String chars,int startX, int startY,int keyWidth,int keyHeight)
	{
		int did = addSequence(startKeyIndex,chars);
		return addColumn(startKeyIndex,did,startX,startY,keyWidth,keyHeight);
	}
	

}
