/*
 * Created on May 29, 2007
 *
 * Michael L Brereton - www.ewesoft.com
 * 
 * 
 */
package eve.ui.data;

import java.net.InetAddress;
import java.net.ServerSocket;

import eve.net.Net;
import eve.server.RemoteAppServer;
import eve.sys.Device;
import eve.ui.Control;
import eve.ui.Gui;
import eve.ui.InputStack;
import eve.ui.ReportException;

/**
 * @author Michael L Brereton
 *
 */
//####################################################
public class AppServer extends RemoteAppServer implements Runnable{

	public RemoteAppServer server;
	public int httpPort = 80;
	
	public AppServer()
	{
		server = this;
	}
	
	ServerSocket created;
	
	public void run()
	{
		runServer(created);
	}
	public Editor getEditor(int options)
	{
		String[] all = new String[] {"Any"};
		try{
			//InetAddress me = InetAddress.getLocalHost();
			InetAddress [] addr = Net.getLocalAddresses(false,true);
			if (addr.length > 0){
				all = new String[addr.length+1];
				all[0] = "Any";
				for (int i = 0; i<addr.length; i++)
					all[i+1] = addr[i].getHostAddress();
			}
		}catch(Exception e){}
		Editor ed = new Editor(server);
		InputStack is = new InputStack();
		is.doubleLined = Device.isMobile();
		is.inputLength = 20;
		ed.addField(is.addComboBox("Host Name",all,0),"hostName");
		ed.addField(is.addInput("Host Port",""),"hostPort");
		ed.addField(is.addInput("Http Port",""),"httpPort");
		ed.addLast(is).setCell(Control.HSTRETCH);
		return ed;
	}
	/**
	 * Open a dialog box and run the server if selected by the user.
	 * @param saveConfig true to save the config info.
	 * @throws Exception if an error occurs during execution of the app.
	 */
	public ServerSocket [] runServer(final AppServer appletServer)
	{
		while(true){
			Editor ed = getEditor(0);
			ed.title = "Start Application Server";
			Gui.setOKCancel(ed);
			if (false){
				//Skip the dialog box.
			}else{
				if (ed.execute() == ed.IDCANCEL) return null;
			}
			try{
				boolean useAny = (hostName.trim().length() == 0 || hostName.trim().equalsIgnoreCase("any"));
				final ServerSocket ss = useAny ? new ServerSocket(hostPort,0) : new ServerSocket(hostPort,0,InetAddress.getByName(hostName));
				isAppletServer = false;
				created = ss;
				final ServerSocket http = useAny ? new ServerSocket(httpPort,0) : new ServerSocket(httpPort,0,InetAddress.getByName(hostName));
				appletServer.created = http;
				appletServer.isAppletServer = true;
				new Thread(this).start();
				new Thread(appletServer).start();
				ServerSocket[] both = new ServerSocket[2];
				both[0] = ss; both[1] = http;
				return both;
			}catch(Exception e){
				new ReportException(e,"The server could not start on that port.",null,false).execute();
			}
		}
	}
	/*
	public static void main(String[] args) throws Exception
	{
		Application.startApplication(args);
		try{
			final AppServer rs = new AppServer();
			RemoteAppEntry re = new RemoteAppEntry("EveMaker","com.eve.evemaker.EveMaker");
			//re.zipFile = File.getNewFile("f:\\projects\\builds\\evemaker\\evemaker.zip");
			//re.eveFile = File.getNewFile("f:\\projects\\builds\\evemaker\\evemaker.eve");
			re.directories.add(File.getNewFile("f:\\projects\\eve\\apps"));
			rs.addApplication(re);
			ServerSocket[] ss = rs.runServer();
			if (ss == null) {
				Application.exit(0);
				return;
			}
			System.out.println("Running server on: "+ss[0].getInetAddress().getHostAddress()+":"+ss[0].getLocalPort());
		}catch(Throwable e){
			new ReportException(e).execute();
			Application.exit(0);
		}
	}
	*/
}
//####################################################

