package eve.ui.event;

import eve.ui.Control;
import eve.ui.Menu;

//##################################################################
public class MenuEvent extends ControlEvent {
//##################################################################

public static final int SELECTED = 30000, DESELECTED = 30001, CLICKED = 30002, ABORTED = 30003, SELECTION_CHANGED = 30004;
public static final int NEXT_MENU_RIGHT = 30005, NEXT_MENU_LEFT = 30006;
/**
* This is relevant only when the event type is SELECTED, DESELECTED or CLICKED. It will
* be EITHER a MenuItem representing the relevant item, or a String representing the text
* of the relevant item.
**/
public Object selectedItem;
/**
* This is the Menu that generated the event, which is not necessarily the "target" for the
* event. The target for the event may change as the event goes up a chain of sub-menus,
* or up into a MenuBar container. All these controls "take over" the event and make themselves
* the target. However the "menu" value will always stay the same.
**/
public Menu menu;

//==================================================================
public MenuEvent(int type,Control target,Object item)
//==================================================================
{
	super(type,target);
	if (target instanceof Menu) menu = (Menu)target;
	selectedItem = item;
}

//##################################################################
}
//##################################################################

