package eve.ui.event;

import eve.sys.Event;
import eve.ui.Control;
import eve.ui.MenuItem;
import eve.ui.SoftKeyBar;

//##################################################################
public class SoftKeyEvent extends Event{
//##################################################################
public static final int ACTION = 350;

{
	type = ACTION;
}
/**
This is the bar that generated the event.
**/
public SoftKeyBar bar;
/**
This is the SoftKey that generated the event, starting from a value
of 1 for the left key.
**/
public int whichKey;
/**
This is the action for the button or for the selected menu item if available.
**/
public String action;
/**
If the event was caused by a menu item selection, then this will be that selected item.
**/
public MenuItem selectedItem;
/**
If the SoftKey button or menu item was a proxy for another control (usually a button)
then this will be set to be that Control.
**/
public Control proxy;
/**
If the SoftKeyEvent was generated by a button or menu item that is associated with
a proxy control, then call doAction() on that proxy and then return true. Otherwise
do nothing and return false.
*/
//===================================================================
public boolean fireProxyAction()
//===================================================================
{
	if (proxy == null) return false;
	proxy.notifyAction();
	return true;
}

//##################################################################
}
//##################################################################

