package eve.ui.filechooser;
import java.util.Hashtable;
import java.util.Vector;

import eve.fx.IImage;
import eve.io.FileChooserParameters;
import eve.sys.Device;
import eve.sys.Type;
import eve.ui.Button;
import eve.ui.Choice;
import eve.ui.data.Editor;
/**
* This class exists only as a container for some of the FileChooser static variables.
**/
//##################################################################
public class FileChooserBase extends Editor{
//##################################################################
public static IImage folderUp = loadImage("eve/FolderUp.png");
public static IImage drive = loadImage("eve/Drive.png");
public static IImage computer = loadImage("eve/Computer.png");
public static IImage palm = loadImage("eve/Palm.png");
public static IImage handHeld = loadImage("eve/HandHeld.png");
/**
* Do not set this directly.
**/
//public static ImageCache toolButtons;

public static boolean allowFileViewing = !Device.isMobile();

/**
* This is initially null. You can create a Vector for it and then add some FileChooserLink objects to it.
These links will show up for all FileChooser boxes for this application.
**/
public static Vector globalLinks;
/**
* Do not set this initially, it is only used when the user accepts a file. Then, this can be used
* along with the "chosenFiles" Vector for selecting multiple files.
**/
public String chosenDirectory;
/**
* Do not set this initially, it is only used when the user accepts a file. Then, this can be used
* along with the "chosenDirectory" field for selecting multiple files. It will contain a set of file names.
**/
public Vector chosenFiles;
/**
* This is the standard allFilesMask. By default it is "*.* - All Files.".
**/
public static String allFilesMask = "*.* - All Files.";
/**
* This is an option for use in the constructor. It is mutually exclusive with:
* OPEN, DIRECTORY_SELECT, BROWSE
**/
public static final int SAVE = 1;
/**
* This is an option for use in the constructor. It is mutually exclusive with:
* SAVE, DIRECTORY_SELECT, BROWSE
**/
public static final int OPEN = 2;
/**
* This is an option for use in the constructor. It is mutually exclusive with:
* SAVE, OPEN, BROWSE
**/
public static final int DIRECTORY_SELECT = 3;
/**
* This is an option for use in the constructor. It is mutually exclusive with:
* SAVE, OPEN, DIRECTORY_SELECT
**/
public static final int BROWSE = 0;
/**
* This is an option for use in the constrcutor.
* It will cause a single click on a file to select the file and close the FileChooser.

**/
public static final int QUICK_SELECT = FileChooserParameters.OPTION_QUICK_SELECT;
/**
* This is an option for use in the constrcutor.
* For opening, this indicates that the file must exist.
**/
public static final int FILE_MUST_EXIST = FileChooserParameters.OPTION_FILE_MUST_EXIST;
/**
* This is an option for use in the constrcutor.
* This indicates that the directory tree should be displayed.
**/
public static final int DIRECTORY_TREE = FileChooserParameters.OPTION_DIRECTORY_TREE;
/**
* This is an option for use in the constrcutor.
* This indicates that the FileChooser should not allow the directory to be changed.
**/
public static final int NO_DIRECTORY_CHANGE = FileChooserParameters.OPTION_NO_DIRECTORY_CHANGE;
/**
* This is an option for use in the constrcutor.
* This indicates that the FileChooser will accept any file name given - even with wildcard characters ('*')
**/
public static final int ACCEPT_ANY = FileChooserParameters.OPTION_ACCEPT_ANY;
/**
* This is an option for use in the constrcutor - the same as READ_ONLY.
* This disallows any kind of modification to the file system within the FileChooser.
**/
public static final int NO_WRITING = FileChooserParameters.OPTION_READ_ONLY;
/**
* This is an option for use in the constrcutor - the same as NO_WRITING.
* This disallows any kind of modification to the file system within the FileChooser.
**/
public static final int READ_ONLY = FileChooserParameters.OPTION_READ_ONLY;
/**
* This is an option for use in the constrcutor.
* This should be used with DIRECTORY_SELECT to indicate that you are selecting an install directory.
**/
public static final int INSTALL_SELECT = FileChooserParameters.OPTION_INSTALL_SELECT;
/**
* This is an option for use in the constrcutor.
* This forces the use of the Desktop version of the FileChooser.
**/
public static final int DESKTOP_VERSION = FileChooserParameters.OPTION_DESKTOP_VERSION;
/**
* This is an option for use in the constrcutor.
* This tells the system not to confirm overwritting of existing files when the SAVE option is used.
**/
public static final int NO_CONFIRM_OVERWRITE = FileChooserParameters.OPTION_NO_CONFIRM_OVERWRITE;
/**
* This is an option for use in the constrcutor.
* This tells the FileChooser that you are going to be adding extra controls and so a Split panel should
* be used to place the extra control in.
**/
public static final int EXTRA_CONTROL = 0x800;
/**
* This is an option for use in the constrcutor.
* This allows the user to select multiple files.
**/
public static final int MULTI_SELECT = FileChooserParameters.OPTION_MULTI_SELECT;
/**
* This is an option for use in the constrcutor.
* This uses an Explorer type display, with no file mask and no file choosing.
**/
public static final int EXPLORER_TYPE = 0x2000;
/**
* This is an option for use in the constrcutor.
* This is no longer used.
**/
public static final int LAUNCHER_TYPE = 0x4000|EXPLORER_TYPE;
/**
* This is an option for use in the constrcutor.
* This indicates that program execution should not be allowed.
**/
public static final int NO_EXECUTE = FileChooserParameters.OPTION_NO_EXECUTE;
/**
* This is an option for use in the constrcutor.
* This indicates that the file chooser will be embedded in another control
* and should not close when a file is chosen, but rather just fire an ControlEvent.ACTION event.
**/
public static final int EMBEDDED = 0x10000;
/**
* This is an option for use in the constrcutor.
* This indicates that the file chooser will show files with the DIRECTORY_SELECT
* option.
*/
public static final int SHOW_FILES_IN_DIRECTORY_SELECT = 0x20000;

public static final int DONT_SHOW_FILE_EXTENSION = FileChooserParameters.OPTION_DONT_SHOW_FILE_EXTENSION;
/**
* This contains the directories or names of recently opened files.
**/
public static Vector history = new Vector();
/**
* This sets the number of history entries. By default it is 10.
**/
public static int historySize = 10;
/**
* This indicates that only directories should be placed in the history Vector. By default
* it is true.
**/
public static boolean historyDirectoriesOnly = true;

//static Vector extensions = new Vector(), icons = new Vector();
Hashtable icons; 
public static boolean wideScreen; //= Gui.screenIs(Gui.WIDE_SCREEN);
public static boolean desktopWide; //= Gui.screenIs(Gui.DESKTOP_WIDTH);
public static FileChooserOptions lastOptions = new FileChooserOptions();
static Type web = new Type("eve.ui.formatted.data.WebBrowser");
//static Type eweView = new Type("eve.io.EweFileBrowser");
//static Type zipView = new Type("eve.zip.ZipFileBrowser");
Choice directories, historyList;
Button accept;
Choice maskChoices;
String [] viewChoices, sortChoices, newChoices;

public static boolean alwaysUsePopupInputs = false;

//##################################################################
}
//##################################################################

