
package eve.ui.filechooser;
import java.io.IOException;

import eve.io.File;
import eve.io.RandomStream;
import eve.io.filestore.FileStore;
import eve.io.filestore.FileStoreEntryFile;
import eve.sys.Handle;
import eve.sys.Type;
import eve.ui.MessageBox;
import eve.ui.ProgressBarForm;
import eve.ui.ReportException;

//##################################################################
public class FileStoreBrowser implements Runnable{
//##################################################################

public boolean exitSystemOnClose = false, doExec = true;

private File storeFile;
private Class storeType;

//===================================================================
ProgressBarForm getProgress(String doWhat)
//===================================================================
{
	Handle h = new Handle();
	ProgressBarForm pbf = new ProgressBarForm();
	pbf.showStop = true;
	pbf.showBar = false;
	pbf.setTask(h,doWhat);
	pbf.exec();
	return pbf;
}

boolean images = false;

//===================================================================
public void run()
//===================================================================
{
	doRun();
	//ewe.sys.Coroutine.sleep(-1);
}

public FileChooserDemo fcd = new FileChooserDemo();
{
	fcd.initial = "/";
	fcd.asABrowser = fcd.browseOnly = true;
	fcd.title = "File Viewer Options";
	fcd.chooserTitle = "File Contents";
}

boolean isRunning = false;
FileStore store;

//===================================================================
public void doRun()
//===================================================================
{
	/*
	if (which == null && streamName == null && inputStream == null){
		FileChooser fc = new FileChooser(FileChooser.OPEN,"/");
		fc.associateIcon("zip",Control.loadImage("eve/zipsmall.png"));
		fc.title = "Select a Zip File";
		fc.addMask("*.zip,*.jar - Zip and Jar Files");
		fc.addMask(fc.allFilesMask);
		if (fc.execute() == fc.IDCANCEL)
			return;
		which = fc.getChosen();
	}
	*/
	try{
		if (store == null){
			ProgressBarForm pbf = getProgress("Opening...");
			try{
				RandomStream rs = storeFile.toRandomStream("r");
				Type t = new Type(storeType);
				store = (FileStore)t.newInstance("Leve/io/RandomStream;Ljava/lang/String;",new Object[]{rs,storeFile.getFileExt()});
				if (store == null) return;
			}finally{
				pbf.close(0);
			}
		}
		ProgressBarForm pbf = getProgress("Creating file tree...");
		FileStoreEntryFile zef = null;
		try{
			zef = store.getFileSystem(pbf.handle);
		}finally{
			pbf.close(0);
		}
		if (zef == null || !zef.isValid()){
			if (!pbf.handle.shouldStop)
				new MessageBox("Error","The tree could not be created!",MessageBox.MBOK).execute();
			return;
		}
		boolean es = exitSystemOnClose;
		exitSystemOnClose = false;
		fcd.aFile = zef;
		fcd.doExec = doExec;
		isRunning = true;
		fcd.runDemo(es);
	}catch(Exception e){
		new ReportException(e).execute();
	}finally{
		if (exitSystemOnClose) System.exit(0);
	}
}
	/*
//===================================================================
public  FileStoreBrowser()
//===================================================================
{
}
*/
private void setup(FileStore store, boolean isModal)
throws IOException
{
	this.store = store;
	exitSystemOnClose = false;
	doExec = isModal;
	new Thread(this).start();
}
/**
Create an EweFileBrowser that will automatically show itself.
**/
//===================================================================
public FileStoreBrowser(FileStore store, boolean isModal)
throws IOException
//===================================================================
{
	setup(store,isModal);
}

//===================================================================
public FileStoreBrowser(File file, Class storeType, boolean isModal, long maxSize)
throws IOException
//===================================================================
{
	if (file.getLength() > maxSize && maxSize > 0)
		throw new IOException("File too big.");
	this.storeFile = file;
	this.storeType = storeType;
	setup(store,isModal);
}
/*
//===================================================================
public static void main(String args[])
//===================================================================
{
	Application.startApplication(args);
	FileStoreBrowser zb = new FileStoreBrowser();
	zb.exitSystemOnClose = true;
	zb.run();
	if (!zb.isRunning) System.exit(0);
}
*/
//##################################################################
}
//##################################################################

