package eve.ui.filechooser;
import eve.sys.Device;
import eve.ui.CellPanel;
import eve.ui.Input;
import eve.ui.InputStack;
import eve.ui.MessageBox;
import eve.ui.Window;
import eve.ui.data.Editor;
import eve.ui.data.LiveObject;

//##################################################################
public class NewShortcut extends LiveObject{
//##################################################################

public String shortcutName = "Shortcut.lnk";
public String target = "";
public String arguments = "";

public void addToPanel(CellPanel cp,Editor ed,int which)
{
	InputStack is = new InputStack();
	is.doubleLined = true;
	FileInput mf;
	is.add(ed.addField(new Input(),"shortcutName"),"Name:");
	is.add(ed.addField(mf = new FileInput(),"target"),"Target:");
	is.add(ed.addField(new Input(),"arguments"),"Program Arguments:");
	mf.title = "Select Shortcut Target";
	mf.masks.add("*.exe;*.eve - Exe/Eve Files.");
	mf.masks.add("*.class - Java Class Files.");
	mf.masks.add(FileChooser.allFilesMask);
	cp.addLast(is);
	ed.title = "New Shortcut";
	ed.doButtons(ed.OKB|ed.CANCELB);
}

//===================================================================
public void fieldChanged(String fieldName,Editor ed)
//===================================================================
{
	if (fieldName.equals("target")){
		if (target.endsWith(".class")){
			MessageBox mb = new MessageBox("Run with Eve?","Do you want to use the Eve VM\nto run that class file?",MessageBox.MBYESNO);
			mb.windowFlagsToClear |= Window.FLAG_HAS_CLOSE_BUTTON;
			if (mb.execute() == mb.IDNO) return;
			String path = target.substring(0,target.length()-6);
			StringBuffer programDir = new StringBuffer();
			String cls = FileChooser.askClassName(target,programDir,null);
			if (cls == null) return;
			target = Device.getPathToVm();
			arguments = "/d \""+programDir.toString()+"\" "+cls;
			ed.toControls("arguments,target");
		}
	}
}
//##################################################################
}
//##################################################################

