
package eve.ui.filechooser;
import java.io.IOException;
import java.io.InputStream;

import eve.io.ByteArrayRandomStream;
import eve.io.File;
import eve.io.RandomStream;
import eve.sys.Handle;
import eve.sys.Vm;
import eve.ui.Application;
import eve.ui.Control;
import eve.ui.MessageBox;
import eve.ui.ProgressBarForm;
import eve.zipfile.ZipEntryFile;
import eve.zipfile.ZipFile;

//##################################################################
public class ZipFileBrowser implements Runnable{
//##################################################################

public boolean exitSystemOnClose = false, doExec = true;

//===================================================================
ProgressBarForm getProgress(String doWhat)
//===================================================================
{
	Handle h = new Handle();
	ProgressBarForm pbf = new ProgressBarForm();
	pbf.showStop = true;
	pbf.showBar = false;
	pbf.setTask(h,doWhat);
	pbf.exec();
	return pbf;
}
boolean images = false;

public String streamName = null;
public InputStream inputStream = null;
public boolean simulateCanWrite = false;
//===================================================================
public void run()
//===================================================================
{
	doRun();
	//ewe.sys.Coroutine.sleep(-1);
}

public FileChooserDemo fcd = new FileChooserDemo();

{
	fcd.initial = "/";
	fcd.asABrowser = fcd.browseOnly = true;
	fcd.title = "Zip File Viewer Options";
	fcd.chooserTitle = "Zip File Contents";
}
boolean isRunning = false;
//===================================================================
public void doRun()
//===================================================================
{
	String which = streamName;
	/*
	int arg = 0;
	for (arg = 0; arg<mApp.programArguments.length; arg++)
		which = checkArg(arg,which);
		*/
	if (which == null && streamName == null && inputStream == null){
		FileChooser fc = new FileChooser(FileChooser.OPEN,"/");
		fc.associateIcon("zip",Control.loadImage("eve/zipsmall.png"));
		fc.title = "Select a Zip File";
		fc.addMask("*.zip,*.jar - Zip and Jar Files");
		fc.addMask(fc.allFilesMask);
		if (fc.execute() == fc.IDCANCEL)
			return;
		which = fc.getChosen();
	}
	ProgressBarForm pbf = getProgress("Opening zip file...");
	ZipFile zf = null;
	if (streamName == null) streamName = "Zip File";
	try{
		if (inputStream == null) {
			inputStream = Vm.openResource(null,which);
		}
		if (inputStream == null){
			pbf.close(0);
			new MessageBox("Error","Could not open zip file!",MessageBox.MBOK).execute();
		}
		if (inputStream instanceof RandomStream)
			zf = new ZipFile((RandomStream)inputStream,streamName,pbf.handle);
		else
			zf = new ZipFile(new ByteArrayRandomStream(inputStream,null),streamName,pbf.handle);
	}catch(Exception e){
	}finally{
		pbf.close(0);
	}
	if (zf == null){
		if (!pbf.handle.shouldStop)
			new MessageBox("Error","That file cannot be read!",MessageBox.MBOK).execute();
		if (exitSystemOnClose) System.exit(0);
		return;
	}
	pbf = getProgress("Creating file tree...");
	ZipEntryFile zef = null;
	try{
		zef = new ZipEntryFile(zf,pbf.handle);
		//zef.simulateCanWrite = simulateCanWrite;
	}catch(Exception e){
		
	}finally{
		pbf.close(0);
	}
	if (zef == null || !zef.isValid()){
		if (!pbf.handle.shouldStop)
			new MessageBox("Error","The tree could not be created!",MessageBox.MBOK).execute();
		if (exitSystemOnClose) System.exit(0);
		return;
	}
	boolean es = exitSystemOnClose;
	exitSystemOnClose = false;
	fcd.aFile = zef;
	fcd.doExec = doExec;
	isRunning = true;
	fcd.runDemo(es);
}
//===================================================================
public  ZipFileBrowser()
//===================================================================
{
}
/**
Create an EweFileBrowser that will automatically show itself.
**/
//===================================================================
public ZipFileBrowser(File f, boolean isModal, long maxSize)
throws IOException
//===================================================================
{
	if (maxSize > 0 && f.getLength() > maxSize) throw new IOException();
	try{
		inputStream = f.toRandomStream("r");
	}catch(IOException e){
		inputStream = f.toReadableStream();
	}
	streamName = f.getFileExt();
	exitSystemOnClose = false;
	doExec = isModal;
	new Thread(this).start();
}

//===================================================================
public static void main(String args[])
//===================================================================
{
	Application.startApplication(args);
	ZipFileBrowser zb = new ZipFileBrowser();
	zb.exitSystemOnClose = true;
	if (args.length != 0) zb.streamName = args[0];
	zb.run();
	if (!zb.isRunning) System.exit(0);
}
//##################################################################
}
//##################################################################

