package eve.ui.game;
import eve.fx.Point;
import eve.fx.Rect;
import eve.util.mVector;

//##################################################################
public class ImageList extends mVector {
//##################################################################

//==================================================================
public ImageList findImages(Rect where,ImageList dest){return findImages(where,dest,false);}
public ImageList findImages(Rect where,ImageList dest,boolean doingOneImage)
//==================================================================
{
	if (dest == null) dest = new ImageList();
	for (int i = 0; i<size(); i++){
		AniImage im = (AniImage)get(i);
		if (doingOneImage){
			if (where.intersects(im.lastDrawn)) {
				dest.add(im);
				//ewe.sys.Vm.debug(im.lastDrawn+", "+where);
			}
		}else
			if (where.intersects(im.location)) dest.add(im);
	}
	return dest;
}
//==================================================================
public ImageList findHotImages(Point where,ImageList dest)
//==================================================================
{
	if (dest == null) dest = new ImageList();
	for (int i = 0; i<size(); i++){
		AniImage im = (AniImage)get(i);
		if (im.onHotArea(where.x,where.y)) dest.add(im);
	}
	return dest;
}
private static ImageList temp = new ImageList();
//==================================================================
public AniImage findHotImage(Point where)
//==================================================================
{
	temp.clear();
	findHotImages(where,temp);
	if (temp.size() == 0) return null;
	return (AniImage)temp.get(temp.size()-1);
}
/**
* Move the image to the top. Returns true if it was moved, false if it
* was already on top.
**/
//==================================================================
public boolean moveOnTop(AniImage which)
//==================================================================
{
	// (find(which) == size()-1) return false;
	remove(which);
	if ((which.properties & which.AlwaysOnTop) != 0)
		add(which);
	else{
		int i;
		for (i = size(); i != 0; i--){
			AniImage ai = (AniImage)get(i-1);
			if ((ai.properties & which.AlwaysOnTop) == 0) break;
		}
		add(i,which);
	}
	return true;
}
//==================================================================
public boolean moveToBack(AniImage which)
//==================================================================
{
	if (indexOf(which) == 0) return false;
	remove(which);
	add(0,which);
	return true;
}
//##################################################################
}
//##################################################################

