package eve.ui.launcher;

import eve.sys.Device;
import eve.sys.options.VMOptions;
import eve.ui.Button;
import eve.ui.CheckBox;
import eve.ui.InputStack;
import eve.ui.Label;
import eve.ui.MessageFlasher;
import eve.ui.ReportException;
import eve.ui.data.Editor;

public class RemoveInstallation extends Editor{

	public static int LOCAL_MACHINE = 0;
	public static int REMOTE_MACHINE = 1;
	
	public int removeFrom = LOCAL_MACHINE;
	public boolean fileAssociations = true;
	public boolean vmOptions = true;
	public boolean allEwesoft = false;
	
	public RemoveInstallation()
	{
		title = "Remove Eve Installation";
		if (Device.isMobile()){
			removeFrom = LOCAL_MACHINE;
			addLast(new Label("Remove From Device:"),HSTRETCH);
		}else{
			InputStack is = new InputStack();
			addField(is.addChoice("Remove from:",new String[]{"Local Computer","Remote Device"},0),"removeFrom");
			addLast(is,HSTRETCH);
		}
		addField(addLast(new CheckBox("File Associations"),HSTRETCH),"fileAssociations");
		addField(addLast(new CheckBox("VM Options"),HSTRETCH),"vmOptions");
		addField(addLast(new CheckBox("All Ewesoft Configs"),HSTRETCH),"allEwesoft");
		addButton((Button)addField(new Button("Remove"),"remove"));
		doButtons(CANCELB);
	}
	public void allEwesoft_changed(Editor ed)
	{
		if (allEwesoft) {
			vmOptions = true;
			ed.toControls("vmOptions");
		}
	}
	public void execute_remove_action(Editor ed)
	{
		int opt = 0;
		if (fileAssociations) opt |= VMOptions.REMOVE_FILE_ASSOCIATIONS;
		if (vmOptions) opt |= VMOptions.REMOVE_VM_OPTIONS;
		if (allEwesoft) opt |= VMOptions.REMOVE_ALL_EWESOFT_OPTIONS;
		MessageFlasher mf = new MessageFlasher("Removing...",ed,false);
		try{
			VMOptions.removeInstallation(removeFrom == LOCAL_MACHINE, opt);
			mf.flash("Complete!");
		}catch(Throwable t){
			mf.off();
			new ReportException(t).execute();
		}finally{
			mf.off();
		}
	}
}
