package eve.ui.table;
import eve.fx.Color;
import eve.fx.FontMetrics;
import eve.ui.UIConstants;
import eve.util.StringList;

//##################################################################
public class TableCellAttributes implements UIConstants{
//##################################################################

public int row;
public int col;
public boolean isSelected;
public int borderStyle = EDGE_SUNKEN;//BDR_OUTLINE|BF_RECT;
public Color borderColor = Color.Black;
public Color fillColor = Color.White;
public Color foreground = Color.Black;
public boolean clipCellData = false;
/**
* Setting hSpan to >1 will allow the data to spill over to the next cells.
* However you must set the span for the following cells to zero.
* Setting it to -1 will allow it to take up the entire remainder of the row.
**/
public int hSpan = 1;
/**
* This is not used yet.
**/
public int vSpan = 1;
/**
* text may be a single String OR an array of Strings (one for each line).
**/
//public Object text = "Cell";
/**
* If this is true, the TableModel will arrange the text to fit within the 
* bounds of the cell. THIS IS NOT IMPLEMENTED!
**/
public boolean tryFitText = false;
/**
* This is alternate non-textual data to display.
**/
public Object data = null;

public StringList text = new StringList();

public int alignment = CENTER;
public int anchor = CENTER;
public boolean flat = false;
public FontMetrics fontMetrics = null;
public int drawImageOptions = 0;

public TableCellAttributes reset()
{
	if (text == null) text = new StringList();
	text.zero();
	data = null;
	fontMetrics = null;
	return this;
}
//##################################################################
}
//##################################################################

