package eve.ui.table.data.registry;
import java.util.Vector;

import eve.sys.Locale;
import eve.sys.Vm;
import eve.sys.IRegistryKey;
import eve.ui.data.LiveTreeNode;
import eve.util.Utils;

//##################################################################
public class RegistryKeyNode extends LiveTreeNode{
//##################################################################

public IRegistryKey key;

//===================================================================
public RegistryKeyNode(IRegistryKey key)
//===================================================================
{
	this.key = key;
}

//===================================================================
public String getName() {return key.getKeyName();}
//===================================================================
public String toString() {return getName();}
//===================================================================
public boolean canExpand() {return true;}
//===================================================================
public boolean expand()
//===================================================================
{
	children = new Vector();
	String [] all = (String [])key.getSubKeys(0);
	Utils.sort(all,Vm.getLocale().getStringComparer(Locale.IGNORE_CASE),false);
	for (int i = 0;i<all.length;i++){
		IRegistryKey nk = key.getSubKey(all[i]);
		addChild(new RegistryKeyNode(nk));
	}
	return true;
}
//===================================================================
public boolean isLeaf() {return false;}
//===================================================================
public boolean collapse()
//===================================================================
{
	children = null;
	return true;
}

//##################################################################
}
//##################################################################

