package eve.ui.table.data.registry;
import eve.fx.Dimension;
import eve.fx.Font;
import eve.fx.FontMetrics;
import eve.fx.Insets;
import eve.sys.IRegistryKey;
import eve.ui.Control;
import eve.ui.table.GridTableModel;
import eve.ui.table.TableCellAttributes;
import eve.util.Grid;
//##################################################################
public class RegistryTableModel extends GridTableModel{
//##################################################################

{
	verticalScrollUnit = 2;
	fillToEqualWidths = true;
	numCols = 1;
	numRows = 0;
	hasRowHeaders = hasColumnHeaders = false;
	cursorSize = new Dimension(-1,2);
}
boolean first = true;
IRegistryKey myKey;

public String[] getDataAt(int row, int col)
{
	if (data.size() == 0 || myKey == null) return null;
	String[] both = new String[2];
	row = row-row%2;
	both[0] = (String)getCellData(row,0);
	both[1] = (String)getCellData(row+1,0);
	return both;
}
public void needAction()
{
	Grid values = new Grid();
	values.add("<Press action for data>",true);
	values.add("<or select Auto Update>",true);
	setDataAndHeaders(values,null,null);
	if (table != null) {
		calculateSizes(table.getFontMetrics());
		table.update(true);
	}
}

//===================================================================
public void setKey(IRegistryKey myKey)
//===================================================================
{
	
	if (this.myKey == myKey && myKey == null && !first) return;
	this.myKey = myKey;
	first = false;
	//System.out.println(myKey);
	Grid values = new Grid();
	if (myKey == null){
		values.add("<No Data>",true);
		values.add("",true);
	}else{
		StringBuffer sb = new StringBuffer();
		for (int i = 0;;i++){
			Object value = null;
			try{
				value = myKey.getValue(i,sb);
			}catch(IndexOutOfBoundsException e){
				break;
			}
			if (value == null) break;
			String name = sb.toString();
			if (name.length() == 0) name = "(Default Value)";
			values.add(name,true);
			if (value instanceof byte []){
				String out = "[";
				byte [] v = (byte [])value;
				int max = Math.min(v.length,8);
				for (int j = 0; j<max; j++){
					if (j != 0) out += " ";
					String s = Integer.toHexString(v[j] & 0xff);
					while (s.length() < 2) s = '0'+s;
					out += s;
				}
				if (max != v.length) out += " ..";
				out += "]";
				values.add(out,true);
			}else
				values.add(value.toString(),true);
		}
		if (values.size() == 0){
			values.add("<No Data>",true);
			values.add("",true);
		}

	}
	setDataAndHeaders(values,null,null);
	if (table != null) {
		calculateSizes(table.getFontMetrics());
		table.update(true);
	}
}
Insets in = new Insets(4,4,4,4);
//===================================================================
public TableCellAttributes getCellAttributes(int row,int col,boolean isSelected,TableCellAttributes ta)
//===================================================================
{
	ta = super.getCellAttributes(row,col,isSelected,ta);
	ta.alignment = Control.LEFT;
	ta.anchor = Control.WEST;
	ta.fontMetrics = table.getFontMetrics();
	if ((row % 2) == 0) {
		FontMetrics fm = ta.fontMetrics;
		Font f = fm.getFont();
		ta.fontMetrics = table.getFontMetrics(f.changeStyle(Font.BOLD));
	}
	return ta;
}
//===================================================================
public Insets getCellInsets(int row,int col,Insets insets)
//===================================================================
{
	return in;
}

//##################################################################
}
//##################################################################

