package eve.util;

import java.util.Comparator;

/**
 * This is a re-usable wrapper for a Comparator making it a Comparer.
 */
public class ComparatorComparer implements Comparer{

	private Comparator cc;

	public int compare(Object one, Object two) {
		return cc.compare(one,two);
	}
	/**
	 * Create a ComparatorComparer that wraps nothing - you MUST call
	 * set() to assign a Comparator to this Object.
	 */
	public ComparatorComparer(){}
	/**
	 * Create a ComparatorComparer that wraps the specified Comparator.
	 */
	public ComparatorComparer(Comparator cc)
	{
		set(cc);
	}
	/**
	 * Assign a Comparator to this Object and return this Object.
	 */
	public ComparatorComparer set(Comparator cc)
	{
		this.cc = cc;
		return this;
	}


}
