package eve.util;

import java.util.Iterator;

import eve.sys.Cache;

/**
* This is an Iterator which iterates either a single Object or no Object
* at all.
**/
//##################################################################
public class ObjectIterator extends IteratorEnumerator{
//##################################################################
private Object value;
/**
* Create an ObjectIterator which iterates the provided Object only. If
* the specified Object is null, it will iterate through no Objects at
* all (i.e. hasNext() will always return false).
**/
//===================================================================
public ObjectIterator(Object which){value = which;}
//===================================================================

public ObjectIterator()
{
	
}
/**
 * Reset the Iterator to iterate for the specfied Object.
 * @param which the Object to iterate.
 * @return this ObjectIterator.
 */
public ObjectIterator setFor(Object which)
{
	value = which;
	return this;
}

//===================================================================
public boolean hasNext() {return value != null;}
//===================================================================
public Object next() {Object r = value; value = null; return r;}
//===================================================================
public static ObjectIterator getCached(Object forWho)
{
	return ((ObjectIterator)Cache.get(ObjectIterator.class)).setFor(forWho);
}
/**
 * Put this Object in the Cache and return null.
 */
public ObjectIterator cache() 
{
	Cache.put(this);
	return null;
}
public final static Iterator NullIterator = new ObjectIterator(null);

//##################################################################
}
//##################################################################

