package eve.util;
/**
* A Range represents a consecutive sequence of indexes.
**/
//##################################################################
public class Range implements Copyable{
//##################################################################
/**
* This is the first index in the range.
**/
public int first;
/**
* This is the last index in the range (inclusive).
**/
public int last;

public Range(){setEmpty();}

public boolean isEmpty() {return last<first;}
public Range setEmpty() {last = -1; first = 0; return this;}
public Range(int first,int last){set(first,last);}
//===================================================================
public Range set(int first,int last) {this.first = first; this.last = last; return this;}
//===================================================================
public Range set(Range r) {return set(r.first,r.last);}
//===================================================================
public boolean equals(Object other)
//===================================================================
{
	if (!(other instanceof Range)) return false;
	Range p = (Range)other;
	return p.first == first && p.last == last;
}
//===================================================================
public String toString() {return "("+first+"->"+last+")";}
//===================================================================
public Object getCopy()
//===================================================================
{
	return new Range(first,last);
}
//##################################################################
}
//##################################################################

