package eve.zipfile;
import java.io.IOException;

import eve.data.PropertyList;
import eve.io.Io;
import eve.io.filestore.FileStore;
import eve.io.filestore.FileStoreEntryFile;
import eve.sys.Device;
import eve.sys.Handle;
import eve.sys.ImageData;
import eve.sys.Locale;
import eve.sys.Time;
import eve.sys.Vm;
import eve.sys.Wrapper;
//##################################################################
public class ZipEntryFile extends FileStoreEntryFile{
//##################################################################
/*
//===================================================================
public File getNew(File parent,String file)
//===================================================================
{
	ZipEntryFile zf = new ZipEntryFile(zipFile);
	zf.set(parent,file);
	return zf;
}
//===================================================================
public ZipEntryFile(ZipFile zf){this(zf,null);}
*/
protected ZipEntryFile(FileStore fs)
{
	super(fs);
}
protected FileStoreEntryFile createNew(FileStore fs)
{
	if (!(fs instanceof ZipFile)) throw new IllegalArgumentException();
	return new ZipEntryFile(fs);
}
//===================================================================
public ZipEntryFile(ZipFile zf,Handle h)
//===================================================================
{
	super(zf,h);
}

static ImageData zipIcon;
//public boolean simulateCanWrite = false;

//-------------------------------------------------------------------
String [] getDetails(ZipEntry ze,String [] dest,Object source,boolean detailView)
//-------------------------------------------------------------------
{
	if (dest == null) dest = new String[3];
	PropertyList pl = source instanceof PropertyList ? (PropertyList)source : new PropertyList();
	
	Time t = new Time();
	try{
		getModified(t);
	}catch(IOException e){}
	
	Locale l = (Locale)pl.getValue("locale",Vm.getLocale());
	dest[0] = "?";
	
	if (detailView) dest[0] = Io.fileLengthDisplay(getLength());
	else dest[0] = l.format(getLength(),",",0);
	
	long cl = ze == null ? -1 : ze.getCompressedSize();
	if (cl != -1) 
		if (detailView) dest[1] = Io.fileLengthDisplay(cl);
		else dest[1] = l.format(cl,",",0);
		
	t.format = pl.getString("dateFormat",l.getString(l.LONG_DATE_FORMAT,0,0));
	dest[2] = t.toString();
	if (!detailView){
		t.format = pl.getString("timeFormat",l.getString(l.TIME_FORMAT,0,0));
		dest[2] += " "+t;
	}
	return dest;
}
public Wrapper getInfo(int infoCode, Wrapper sourceParameters, int options)
{
	if (sourceParameters == null) sourceParameters = new Wrapper();
	Wrapper ret = new Wrapper();
	switch(infoCode){
	case INFO_DEVICE_ICON:
		if (zipIcon == null) 
			zipIcon = Device.loadPicture("eve/zipsmall.png"); 
		return ret.setObject(zipIcon);
	}
	return super.getInfo(infoCode,sourceParameters,options);
}
/*
//===================================================================
public Object getInfo(int value,Object source,Object resultDestination,int options) 
//===================================================================
{
	try{
	ZipEntry ze = myEntry;
	if (ze != null)
		if (ze.linkTo != null) 
			ze = ze.linkTo;
	switch(value){
			case INFO_DEVICE_NAME:
				return zipFileName;
			case INFO_DEVICE_ICON:
				if (zipIcon == null) 
					zipIcon = Fx.loadPicture("eve/zipsmall.png");
				return zipIcon;
			case INFO_FLAGS:
				if (!(resultDestination instanceof ewe.sys.Long)) 
					resultDestination = new ewe.sys.Long();
				((ewe.sys.Long)resultDestination).value = 
				FLAG_CASE_SENSITIVE|FLAG_SLOW_LIST|(!simulateCanWrite ? FLAG_FILE_SYSTEM_IS_READ_ONLY : 0);
				return resultDestination;
			case INFO_TOOL_TIP:
				String ret = getFileExt();
				if (isDirectory()) return ret;
				String [] dest = getDetails(ze,null,source,false);
				ret += "\n"+dest[0]+" bytes\n"+dest[1]+" compressed\n"+dest[2];	
				return ret;
			case INFO_DETAIL_NAMES:
				return mString.split("Length|Compr.|Date");
			case INFO_DETAIL_WIDTHS:
				PropertyList pl = source instanceof PropertyList ? (PropertyList)source : new PropertyList();
				Locale l = (Locale)pl.getValue("locale",Vm.getLocale());
				String format = pl.getString("dateFormat",l.getString(l.LONG_DATE_FORMAT,0,0));
				return mString.split("LengthXX|Compr.XX|XX-XX-XXXX-");
			case INFO_DETAILS:
				return getDetails(ze,null,source,true);
	}
	}catch(Exception e){
		//e.printStackTrace();
	}
	return null;
}
*/
//##################################################################
}
//##################################################################


