/*
 * Action.java
 *
 * Created on 19 marzo 2009, 12.53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.com.data;

import java.util.logging.*;

import romas.com.data.tables.TABLE;
import romas.com.data.tables.ACTIONS_PROCESS;

import romas.util.LogWriter;
import romas.com.data.Structures.ACTION_STATE;



/**
 *
 * @author APaliani
 */
public class Action extends Thread{
    
    ACTIONS_PROCESS actionProcess;

    boolean isRunning = true;
    
    /** Creates a new instance of Action */
    public Action(ACTIONS_PROCESS actionProcess) {
        this.actionProcess = actionProcess;
        this.isRunning = true;
    }
    
    
    /**
     *Metodo da implementare
     */
    public boolean executeWork(ACTIONS_PROCESS actionProcess){
        return true;
    }
    
    
    /**
     *Ritorna l'id del thread
     */
    public long getThreadId(){
        return super.getId();
    }
    
    
    /**
     *Termina l'esecuzione del thread
     */
    public boolean terminate(){
        try{
            LogWriter.writeLog(Level.WARNING, "Action abort: " + TABLE.toString(actionProcess));
            isRunning = false;
            this.interrupt();
            return true;
        }
        catch(Exception ex){
            LogWriter.writeLog(Level.SEVERE, ex.getMessage());
        }
        return false;
    }
    
    
    /**
     *Imposta la cancellazione della ACTIONS_PROCESS
     */
    protected final void doDeleting(ACTIONS_PROCESS actionProcess){
        LogWriter.writeLog(Level.FINE, "Prepare to delete action: " + TABLE.toString(actionProcess));
        actionProcess.STATE_ACTION_PROCESS = ACTION_STATE.DELETING_ACTION_STATE;
        TableManager.updateACTION_PROCESS(actionProcess);
    }

    
    /**
     *Sovrascrive il metodo del thread
     */
    public void run(){
        int iteration = 0;
        int numberIter = actionProcess.NUMBER_ITERATION_ACTION_PROCESS;
        if(numberIter > -1){
            while((iteration < numberIter)){
                if(executeWork(actionProcess)){
                    iteration++;
                    actionProcess.NUMBER_ITERATION_ACTION_PROCESS--;                    
                }
                else{
                    LogWriter.writeLog(Level.WARNING, "Action not executed: " + TABLE.toString(actionProcess));
                    iteration = numberIter;
                    terminate();
                }
            }                                        
        }
        else{
            while(isRunning){
                executeWork(actionProcess);
            }                                        
        }
        doDeleting(actionProcess);
    }    
}
