/*
 * Logger.java
 *
 * Created on 23 febbraio 2009, 15.21
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.util;

import java.util.logging.*;
import java.io.FileWriter;

/**
 *
 * @author APaliani
 */
public class LogWriter {
   
    
    static Logger logger;
    static FileWriter writer;
    static Level logLevel;

    static int printedNumberChar = 0;
    static int numberChar = 0;
    /**
     *Costruttore da 
     */    
    public LogWriter(){}
    
    
    /**
     * Level: "SEVERE", "WARNING", "INFO", "CONFIG", "FINE", "FINER", "FINEST", "ALL"    
     *
     */
    public static void init(String fileName, String logLevelName) throws Exception{
    
        writer = new FileWriter(fileName, false);
        logLevel = Level.parse(logLevelName);
    }
    
    
    /**
     *Scrive il file di log
     */    
    public synchronized static void writeLog(Level level, String message)
    {
        
        try
        {
            if(writer == null)
            {
                init("romas.log", "ALL");
            }
            
            Throwable t = new Throwable();

            StackTraceElement[]  trace = t.getStackTrace();
            if(trace.length > 0)
            {                
                writeMessage(level, trace[1].getClassName() + "." + trace[1].getMethodName() + " : " + message);
            }
            else
            {
                writeMessage(level, message);                
            }
        }
        catch(Exception ex)
        {
            System.err.println(ex.getMessage());
        }
    }
    
    
    private static void writeMessage(Level levelMessage, String message)throws Exception
    {
        if(levelMessage.intValue() >= logLevel.intValue())
        {
            String newMsg = romas.util.Utility.getDateTime() + " > " + Utility.padString(levelMessage.getLocalizedName(), " ", 10, Utility.PADDING_RIGHT) + " > " + message;
            writer.write("\n" + newMsg + " ");
            writer.flush();
            System.out.println(newMsg);
        }        
    }


    /**
     * Prin console execution
     *
     */
    public synchronized static void printExecution()throws Exception
    {
        switch(numberChar)
        {
            case 0:
                System.out.print(".");
                break;
            case 1:
                System.out.print("|");
                break;
            case 2:
                System.out.print("/");
                break;
            case 3:
                System.out.print("-");
                break;
            case 5:
                System.out.print("\\");
                numberChar = -1;
                break;
        }

        numberChar++;

        Thread.sleep(300);
        System.out.print("\u0008");
    }











}
