/*
 * ServoConfiguration.java
 *
 * Created on 23 marzo 2009, 16.41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.util.comunication.controller.servo;

/**
 *
 * @author APaliani
 */
public class ServoConfiguration {
    
    // Channel number in decimal, 0 - 31
    public int CHANNEL = 0;

    // pulse servo step
    public int STEP = 1;
       
    // ACTUAL Pulse width in microseconds, 500 - 2500
    public int POS_ACTUAL = 750;
    
    // MEDIUM Pulse width in microseconds, 500 - 2500
    public int POS_MEDIUM = 1500;
    
    // MINOR Pulse width in microseconds, 500 - 2500
    public int POS_MIN = 750;
    
    // MAX Pulse width in microseconds, 500 - 2500
    public int POS_MAX = 2250;

    /**
     * Formatted command for servo movement
     */
    public String COMMAND_FORMAT = "#%s P%s S%s";


    // check servo position
    public String QUERY_PULSE = "QP %s";

    // check command end
    public String QUERY_CHECK_COMMAND = "Q";


    public enum SERVO_TOWARDS
    {
        MIN,
        CENTER,
        MAX
    }

    public ServoConfiguration(String configuration)
    {
        loadStringConfiguration(configuration);
    }

    public void loadStringConfiguration(String configuration)
    {
        String[] params = configuration.split(";");
        CHANNEL = Integer.valueOf(params[0]).intValue();
        STEP = Integer.valueOf(params[1]).intValue();
        POS_MIN = Integer.valueOf(params[2]).intValue();
        POS_MEDIUM = Integer.valueOf(params[3]).intValue();
        POS_MAX = Integer.valueOf(params[4]).intValue();
        COMMAND_FORMAT = params[5];
    }
}
