/*
 * SerialWriter.java
 *
 * Created on 24 febbraio 2009, 10.55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.util.comunication.port;

/**
 *
 * @author APaliani
 */
import gnu.io.*;
import java.io.*; 
import java.util.Enumeration;
  

/**
 * Questa classe permette di scrivere sulla porta 
 * seriale il cui nome specificato nel costruttore 
 * della stessa. 
 **/
public class SerialWriter  { 
  
    // Crea un oggetto che scrive il valore della stringa 
    // message sulla porta seriale port. 
    // 
    public SerialWriter(String port, String message){ 
        try{ 

            // Prendiamo il descrittore della porta scelta.  
            // Nel caso in cui la porta non esista verr 
            // sollevata una eccezione di tipo 
            // NoSuchPortException. 
            Enumeration enumPorts = CommPortIdentifier.getPortIdentifiers();
            CommPortIdentifier id_porta = CommPortIdentifier.getPortIdentifier(port); 

            // Proviamo a prendere l'ownership della porta data.  
            // Nel caso in cui la porta sia gi occupata verr  
            // sollevata una eccezione 
            // di tipo PortInUseException 
            CommPort porta=id_porta.open("ScriviSuSeriale",200); 

            // Otteniamo un riferimento all'OutputStream  
            // della porta 
            OutputStream out = porta.getOutputStream();  
            
            SerialPort porta_seriale = (SerialPort)porta;             
            porta_seriale.setSerialPortParams(115200, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE); 
            
            // Procediamo, quindi, alla scrittura del  
            // messaggio sulla porta 
            PrintStream ps = new PrintStream(out);                         

            //ps.write(message.getBytes());
            char extChar = (char)13;
            String ss = message + extChar;
            byte[] outByte = ss.getBytes(); 
            out.write(outByte);
                       
            //Chiudiamo la porta 
            ps.close(); 
            porta.close(); 
        } 
        catch(NoSuchPortException ne){ 
            System.out.println("Port " + port + " not found."); 
        }catch(PortInUseException pe){ 
            System.out.println("Port " + port + " is busy, from " + pe.currentOwner); 
        }catch(UnsupportedCommOperationException ue){ 
            System.out.println("Inavlid settings port !"); 
        }catch(IOException ioe){ 
            System.out.println("IO Error"); 
        }// fine try/catch 

    }// fine costruttore
  

    public static void main(String[] args){ 
        try{
            if((args == null) || (args.length == 0)){
                SerialWriter serialWriter = new SerialWriter("COM3", "#0 P1500");
            }
            else{
                SerialWriter serialWriter = new SerialWriter(args[0], args[1]);
            }
            
            //Thread.sleep(20000);
        }
        catch(Exception ex)
        {
            System.out.println("Error: " +  ex.getMessage());            
        }
    }// fine 
  

}// fine