/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package romas.util.io;

/**
 *
 * @author apaliani
 */
/*
 * Author:  andbin - http://andbin.altervista.org
 * License: Public Domain
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 */

import java.awt.*;
import java.io.*;
import java.text.*;
import javax.swing.*;

//public class SafeOverwriteFileChooserDemo {
//    public static void main(String[] args) {
//        SwingUtilities.invokeLater(new Runnable() {
//            public void run() {
//                JFileChooser chooser = new SafeOverwriteFileChooser();
//                chooser.showSaveDialog(null);
//            }
//        });
//    }
//}


public class SafeOverwriteFileChooser extends JFileChooser {
    private static final String DEFAULT_CONFIRM_TITLE = "Confirma";
    private static final String DEFAULT_CONFIRM_MESSAGE = "Il file ''{0}'' esiste \nSi desidera sovrascriverlo?";

    private String confirmTitle;
    private String confirmMessage;

    public SafeOverwriteFileChooser() {
        this(DEFAULT_CONFIRM_TITLE, DEFAULT_CONFIRM_MESSAGE);
    }

    public SafeOverwriteFileChooser(String confirmTitle, String confirmMessage) {
        this.confirmTitle = confirmTitle;
        this.confirmMessage = confirmMessage;
    }

    public void approveSelection() {
        if (getDialogType() == SAVE_DIALOG) {
            File f = getSelectedFile();

            if (f.exists()) {
                String msg = MessageFormat.format(confirmMessage, new Object[] { f });

                int r = JOptionPane.showConfirmDialog(this, msg, confirmTitle, JOptionPane.YES_NO_OPTION);

                if (r == JOptionPane.NO_OPTION) {
                    // Returns without approve the selection.
                    return;
                }
            }
        }

        // Approves the selection normally.
        super.approveSelection();
    }
}