/*
 * VideoStreamServer.java
 *
 * Created on 23 febbraio 2009, 17.07
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.services.comunications;


import java.net.*;
import java.util.Vector;

import romas.services.*;
import romas.com.data.Structures.SERVICE_TYPE;
import romas.com.data.tables.TABLE;
import romas.com.data.tables.NOTIFICATIONS_MAP;
import romas.com.data.tables.ACTIONS_PROCESS;

import java.util.logging.Level;
import java.util.List;

import romas.util.LogWriter;
/**
 *
 * @author APaliani
 */
public class ComunicationService extends NotificationService{

    ServerSocket serverSocket;
    public static boolean done = false;
    int m_serverPort = 0;

    Vector _actionsAvailable;

    /** Creates a new instance of VideoStreamServer */
    public ComunicationService() throws Exception{
        super("ComunicationService");
    }

    public String getCurrentVersion()
    {
        return "2011.05.26.0258";
    }

    public int getPriorityScope()
    {
        return SERVICE_TYPE.SECONDARY_SERVICE;
    }


    public List<NOTIFICATIONS_MAP> prepareAction()
    {
        return null;
    }


    /**
     *Da implementare per eseguire le azioni
     */
    protected boolean actionWork(ACTIONS_PROCESS actionProcess)
    {
        LogWriter.writeLog(Level.FINE, TABLE.toString(actionProcess));

        if(actionProcess.NAME_ACTION_ACTIONS_PROCESS.equals("SERVER"))
        {
            try{
                if(actionProcess.COMMAND_ACTIONS_PROCESS.equals("START"))
                {
                    int serverPort = Integer.valueOf(actionProcess.PARAMS_ACTIONS_PROCESS.get(0).toString()).intValue();
                    startServer(serverPort);
                }

                if(actionProcess.COMMAND_ACTIONS_PROCESS.equals("STOP"))
                {
                    stopServer();
                }

            }catch(Exception ex){

                LogWriter.writeLog(Level.SEVERE, ex.getMessage());
                return false;
            }
        }

        return true;
    }


    /**
     *Avvia il server
     */
    public void startServer(int serverPort)throws Exception{

        try{
            m_serverPort = serverPort;
            serverSocket = new ServerSocket(serverPort);

            LogWriter.writeLog(Level.INFO, "ComunicationService server started on host:"+ serverSocket.getInetAddress() +" port ("+ serverPort + ") ... \n");

            if(buildAvailableActions()){
                clientListener();
            }

            close();
        }
        catch(Exception ex){
            LogWriter.writeLog(Level.SEVERE, ex.getMessage());
            close();
        }
    }

    private void close()throws Exception{
        serverSocket.close();

        LogWriter.writeLog(Level.INFO, "ComunicationService STOP !");

        // notifica la direttiva da caricare
        NOTIFICATIONS_MAP notify = new NOTIFICATIONS_MAP();
        notify.PARAMS_COMMAND_EVENT = null;
        notify.ACTION_EVENT = "SERVER";
        notify.COMMAND_EVENT = "STOP";
        String actionFULLNAME = this.getScope() + "_" + notify.ACTION_EVENT + "_" + notify.COMMAND_EVENT;
        notify.FULLNAME_EVENT = actionFULLNAME;
        notify.NUMBER_ITERATION_NOTIFY = 1;
        notify.ACTIVE = true;
        this.notifyAction(notify);
    }

    /**
     *Attende la connessione dei clients
     */
    private void clientListener()throws Exception
    {
        while (!done){
            LogWriter.writeLog(Level.INFO, "Server listening ... ");
            Socket clientSocket = serverSocket.accept();
            String msg = "da indirizzo [" + clientSocket.getInetAddress() + "] sulla porta del server [" + clientSocket.getPort() + "]";
            LogWriter.writeLog(Level.INFO, "Connected client ... " +  msg);

            Thread.sleep(100);

            Vector params = new Vector();
            params.add(msg);
            // notifica la direttiva da caricare
            NOTIFICATIONS_MAP notify = new NOTIFICATIONS_MAP();
            notify.PARAMS_COMMAND_EVENT = params;
            notify.ACTION_EVENT = "CLIENT_CONNECTION";
            notify.COMMAND_EVENT = "OPEN";
            String actionFULLNAME = this.getScope() + "_" +notify.ACTION_EVENT + "_" + notify.COMMAND_EVENT;
            notify.FULLNAME_EVENT = actionFULLNAME;
            notify.NUMBER_ITERATION_NOTIFY = 1;
            notify.ACTIVE = true;
            this.notifyAction(notify);

            Thread.sleep(1000);

            ClientComunicationSocket clientStreamSocket = new ClientComunicationSocket(clientSocket, this);
            clientStreamSocket.start();
        }
    }


    /**
     *Arresta il server
     */
    public void stopServer()
    {
        try{
            LogWriter.writeLog(Level.INFO, "ComunicationService STOP !");
            serverSocket.close();
        }
        catch(Exception ex){
            LogWriter.writeLog(Level.SEVERE, ex.getMessage());
        }
    }


    /**
     * Ritorna la lista delle azioni disponibili
     * @return
     */
    public Vector getAvailableActions(){

        return _actionsAvailable;
    }


    /**
     *Rileva i dispositivi connessi al server
     */
    private boolean buildAvailableActions(){

        _actionsAvailable = new Vector();
        return true;
    }
}
