/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package romas.services.resources;

import romas.services.*;
import romas.com.data.Structures.*;
import romas.com.data.tables.NOTIFICATIONS_MAP;
import romas.com.data.tables.ACTIONS_PROCESS;
import romas.util.*;
import java.util.logging.Level;
import romas.services.resources.boards.*;
import java.util.Hashtable;
import java.util.List;

/**
 *
 * @author armando
 */
public class ResourcesService extends NotificationService{

    private Hashtable m_resources;

    public ResourcesService(Hashtable resources) throws Exception{
        super("ResourcesService");
        
    }

    public String getCurrentVersion()
    {
        return "2011.05.26.0108";
    }



    public void addResource(String key, Object resource){

        m_resources.put(key, resource);
    }


    public Hashtable getInitResources(){
        m_resources = new Hashtable();

        addResource("arduino2009", getArduino2009());
        
        return m_resources;
    }

    public List<NOTIFICATIONS_MAP> prepareAction() {
        return null;
    }
    
    protected boolean actionWork(ACTIONS_PROCESS actionProcess) {
        return true;
    }
    /**
     * Set priority scope
     */
    public int getPriorityScope() {
        return SERVICE_TYPE.PRIMARY_SERVICE;
    }



    private Arduino2009 getArduino2009(){
        Arduino2009 arduino2009 = null;
        try{
            String arduinoPortName = config.getPropertiesValue("board_arduino2009_port");
            LogWriter.writeLog(Level.INFO, "........................ board: Arduino 2009 on port: "+ arduinoPortName +"\n");
            arduino2009 = new Arduino2009(arduinoPortName, 9600);            
        }catch(Exception ex){
            LogWriter.writeLog(Level.SEVERE, ex.getMessage());
        }
        return arduino2009;
    }
}
