package romas.util.win.RoboIO;

import java.io.IOException;

 public class Servo {
	static
	{
		try
                {
                        System.out.println(System.getProperty("user.dir"));
			System.loadLibrary("RoBoIo_Java");
		}
		catch (UnsatisfiedLinkError e)
			{
				System.err.println(e);
				System.exit(1);
			}
	}

   public static void main(String argv[]) {
	long[] home  = new long[32];
	long[] frame = new long[32];
	for (int i = 0; i < 31; i++)
	{
		home[i]  = 0;
		frame[i] = 0;
	}


//        try{
//        while (true)
//        {
//            Thread.sleep(2000);
//        }}catch(Exception e){}

	// first set the correct RoBoard version
        System.out.println("init roboard!");
	//RoBoIO.roboio_SetRBVer(RoBoIO.RB_100);
        RoBoIO.roboio_SetRBVer(100);
	//RoBoIO.roboio_SetRBVer(RoBoIO.RB_110);  // if your RoBoard is RB-110
	//RoBoIO.roboio_SetRBVer(RoBoIO.RB_050);  // if your RoBoard is RB-050

        System.out.println("set no feedback!");

	RoBoIO.rcservo_SetServo(19, RoBoIO.RCSERVO_SERVO_DEFAULT_NOFB);     // select the servo model on pin S1 as non-feedback servo
        System.out.println("19!");

	RoBoIO.rcservo_SetServo(20, RoBoIO.RCSERVO_SERVO_DEFAULT_NOFB);     // select the servo model on pin S2 as non-feedback servo
	System.out.println("20!");
        if (RoBoIO.rcservo_Init(RoBoIO.RCSERVO_USECHANNEL19 + RoBoIO.RCSERVO_USECHANNEL20) == false)  // set PWM/GPIO pins S1 & S2 as Servo mode
	{
		System.out.println("ERROR: fail to init RC Servo lib (" + RoBoIO.roboio_GetErrMsg() + ")!");
		System.exit(1);
	}

	home[0] = home[1] = 1500;  // set the initial home position of all servos as 1500us
        System.out.println("GO!");
	RoBoIO.rcservo_EnterPlayMode_HOME(home);  // enter Action Playing Mode for moving servos

	System.out.println("press ENTER to move servo on pins S19 & S20.");
	try {
		System.in.read();
		while (System.in.available() > 0)
			System.in.read(); //flush the buffer
	} catch (IOException e) {
		e.printStackTrace();
	}
	frame[0] = 900;   // move the servo on pin S1 to position 900us
	frame[1] = 1800;  // move the servo on pin S2 to position 1800us
	RoBoIO.rcservo_MoveTo(frame, 2000);  // move servos to the target positions in 2000ms

	System.out.println("press ENTER to move only the servo on pin S1.");
	try {
		System.in.read();
		while (System.in.available() > 0)
			System.in.read(); //flush the buffer
	} catch (IOException e) {
		e.printStackTrace();
	}
	RoBoIO.rcservo_MoveOne(19, 1800, 500);  // move the servo to position 1800us in 300ms

	System.out.println("press ENTER to move servo on pins S1 & S2.");
	try {
		System.in.read();
		while (System.in.available() > 0)
			System.in.read(); //flush the buffer
	} catch (IOException e) {
		e.printStackTrace();
	}
	frame[0] = 900;   // move the servo on pin S1 to position 900us
	frame[1] = 900;   // move the servo on pin S2 to position 900us
	RoBoIO.rcservo_MoveTo(frame, 3000);  // move servos to the target positions in 3000ms

	System.out.println("Complete.");

	RoBoIO.rcservo_Close();  // close RC Servo lib
   }
 }
