/*
 * Sampler.java
 *
 * Created on 24 febbraio 2009, 11.20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.services.speakrecognition;

/**
 *
 * @author APaliani
 */

import java.io.*;
import java.util.*;
import javax.sound.sampled.*;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.FloatControl;
import java.util.logging.Level;
import romas.util.LogWriter;
import romas.util.fft.*;
/**
 *
 * @author paliani
 */
public class Sampler {
    
    private  float[] WordByte;
    private  double NoiseFloat;
    private  double[] NoiseArray;    
    
    int SampleRate = 10240; //8192; //10240; //16384; //32768; //43008;
    
    int nPackage = 20;
    private int nSamples = SampleRate / nPackage;
    int numBytesToRead = SampleRate / 10;
    
    int speechsize = SampleRate; // 300 * 35
    int speechStopSize = speechsize -200;
    float[] speechArray = new float[speechsize]; // ie. 300 * 30 // 7800 was pretty good too
    int speechArrayIndex = 0;
    int speechFlag = 0; 
    boolean isRunning = false;
    public double noiseMoving=0;
    public int noiseIndex=0;
    public double noise;    
    
    Mixer JavaMixerSource = null;
    Mixer JavaMixerTarget = null;
    
    int indexa;
    int numRead;
    
    byte[] data;
    ByteArrayOutputStream out;
    long progFile = 0;
    Date t;
    TargetDataLine targetLine;
    SourceDataLine sourceLine;
    byte[] capturedBytes;
    AudioFormat captureFormat;
    
    Mixer.Info[] mixinfo = null;
    
    Windowing windowing = null;

    java.util.Hashtable rangesPackages_hashtable;

    CepstrumTransform cepstrumTransform = null;
    FastFourierTransform fft = null;

    /** Creates a new instance of Sampler */
    public Sampler() {
        windowing = new Windowing();
        windowing.setWindowType("Hamming");
        cepstrumTransform = new CepstrumTransform();
        fft = new FastFourierTransform();
    }  
    
    
    private void SetMinimumVolum()
    {
        // regolazione del volume del campionatore
        for (int i = 0; i < mixinfo.length; i++) 
        {
            Mixer mixer = AudioSystem.getMixer(mixinfo[i]);

            Line.Info[] targetLineInfos = mixer.getTargetLineInfo();
            for (int j = 0; j < targetLineInfos.length; j++) {
                    //System.out.println("\ttarget line info:\t" + targetLineInfos[j]);
                    setVolume(targetLineInfos[j], 0);
            }
        }        
    }
    
    private void SetMaximumVolum()
    {
        // regolazione del volume del campionatore
        for (int i = 0; i < mixinfo.length; i++) 
        {
            Mixer mixer = AudioSystem.getMixer(mixinfo[i]);

            Line.Info[] targetLineInfos = mixer.getTargetLineInfo();
            for (int j = 0; j < targetLineInfos.length; j++) {
                    //System.out.println("\ttarget line info:\t" + targetLineInfos[j]);
                    setVolume(targetLineInfos[j], 1);
            }
        }        
    }
    
    
    
    public boolean setVolume(Line.Info lineInfo, float volume_value) {
            try {
                    Line line = AudioSystem.getLine(lineInfo);
                    line.open();
                    FloatControl control = (FloatControl) line.getControl(FloatControl.Type.VOLUME);
                    //System.out.println("\t*** Imposta volume ");
                    //System.out.println("\t\t\t*** vecchio valore = " + control.getValue());
                    control.setValue(volume_value);
                    //System.out.println("\t\t\t*** nuovo valore  = " + control.getValue());
                    line.close();
            } catch (Exception e) {
                    return false;
            }
            return true;
    }
    
    /**
     * Inizializza il campionamento
     */
    public void setup()
    {
        try{

            //---------------------------------------
            // mixers Installed
            //---------------------------------------
            mixinfo = AudioSystem.getMixerInfo();
            int numberOfMixers = mixinfo.length;

            LogWriter.writeLog(Level.INFO, "Mixers disponibili installati:  " + numberOfMixers);


            //------------------------------------------------------------------
            // Get Java Sound Mixers (from displayed installation support above)
            //------------------------------------------------------------------
            JavaMixerSource = AudioSystem.getMixer(mixinfo[0]);
            JavaMixerTarget = AudioSystem.getMixer(mixinfo[1]);


            //-----------------------------------------------------
            // AVAILABLE TARGET LINES (AUDIO INPUT)
            //-----------------------------------------------------
            Line.Info[] targetport = JavaMixerTarget.getTargetLineInfo();
            int numberOfTargets = targetport.length;

            for (int i=0; i< numberOfTargets; i++){
                LogWriter.writeLog(Level.INFO, "Targets: " + targetport[i].toString());
                LogWriter.writeLog(Level.INFO, targetport[i].getLineClass().toString());
                DataLine.Info targetInfo = (DataLine.Info) targetport[i];
                AudioFormat[] targetFormats = targetInfo.getFormats();
             }

            //-----------------------------------------------------
            // AVAILABLE SOURCE LINES (AUDIO OUTPUT)
            //-----------------------------------------------------
            Line.Info[] sourceport = JavaMixerSource.getSourceLineInfo();
            int numberOfSources = sourceport.length;
            LogWriter.writeLog(Level.INFO, "Source: " + sourceport[0].toString());
            LogWriter.writeLog(Level.INFO, sourceport[0].getLineClass().toString());

            for (int i=0; i< numberOfSources; i++){
                DataLine.Info sourceInfo = (DataLine.Info) sourceport[i];
                AudioFormat[] sourceFormats = sourceInfo.getFormats();
                LogWriter.writeLog(Level.INFO, "Source: " + sourceport[0].toString());
                LogWriter.writeLog(Level.INFO, sourceport[0].getLineClass().toString());
            }

            AudioFileFormat.Type[] supportedAudioFormat = AudioSystem.getAudioFileTypes();         
            captureFormat = new AudioFormat(SampleRate, 16, 1, true, true); // Big Endian

            TargetDataLine.Info infor = new DataLine.Info(TargetDataLine.class, captureFormat); 
         
            if(!AudioSystem.isLineSupported(infor))
            {
                throw new LineUnavailableException("La linea " + infor + " non  supportata !");
            }
            
            targetLine = (TargetDataLine) AudioSystem.getLine(infor);
            LogWriter.writeLog(Level.INFO, "Formato: " + targetLine.getFormat());
            targetLine.open(captureFormat);
            LogWriter.writeLog(Level.INFO, "Stato del campionatore: " + targetLine.isOpen());
         
            DataLine.Info info = new DataLine.Info(SourceDataLine.class, captureFormat); 
            LogWriter.writeLog(Level.INFO, "SourceDataLine supported: " + AudioSystem.isLineSupported(info));
         
            sourceLine = (SourceDataLine) JavaMixerSource.getLine(info);  // interface SourceDataLine           
        }
        catch (LineUnavailableException e) { 
            LogWriter.writeLog(Level.SEVERE, "line unavailable due 2 an active program: " + e.getMessage());
        }
        
    }


    /**
     * Da eseguire prima di una sessione di campionamenti
     *
     */
    public void initSessionSampler(){
        try{
            // AVVIO
            indexa = 0;
            // Initialize all the needed variables;
            numRead =0;
            indexa=0;
            NoiseFloat =0;
            speechArrayIndex = 0;
            out  = new ByteArrayOutputStream();
            t = new Date();
            NoiseArray = new double[100];

            sourceLine.open();
            LogWriter.writeLog(Level.INFO, "Stato Campionatore Audio: " + sourceLine.isOpen());
            //sourceLine.drain();
            
            targetLine.start();
            //targetLine.drain();
        }
        catch (LineUnavailableException e) {
            LogWriter.writeLog(Level.SEVERE, "Impossibile attivare sorgente audio: " + e.getMessage());
        }
    }

    /**
     * 
     * 
     * 
     * @param testFrequence  float freq = 3000.0f;
     * @return
     */
    public MetaTagAudio execute(float testFrequence, int freqMin, int freqAmplitude, int numBytesTest, int nSampleRate, int nPackages, int maxPackage, int nDimension, javax.swing.JTextField  semaforo_jTextField){

        nPackage = nPackages;
        SampleRate = nSampleRate;
        nSamples = nSampleRate / nPackages;

        numBytesToRead = nSampleRate / 10;
        data = new byte[numBytesToRead];
        WordByte = new float[numBytesToRead];

        speechsize = nSampleRate; // 300 * 35
        speechStopSize = nSampleRate -200;
        speechArray = new float[speechsize]; // ie. 300 * 30 // 7800 was pretty good too

        rangesPackages_hashtable = new java.util.Hashtable();


        // i passi sono proporzionali ai packages
        int steps = nPackages / 10;
        if(steps == 0) steps = 1;

        // esegue lo scaglionamento dei pacchetti
        for(int i=1; i<=nPackage; i++){
            int topPackage = (((i-1)/steps) * steps) + steps;
            if(topPackage <= nPackage){
                rangesPackages_hashtable.put(i, topPackage);
            }
            else{
                rangesPackages_hashtable.put(i, nPackage);
            }
        }

        // Inizializza la parola campionata
        MetaTagAudio metaTagAudio = new MetaTagAudio();

        try{
            // eseguo il campionamento se non  una frequnza di test
            if(testFrequence == 0){

                //SetMinimumVolum();

                targetLine.flush();

                while (indexa<100)
                {
                    numRead =  targetLine.read(data, 0, numBytesToRead);
                    NoiseFloat = generate(data);
                    NoiseArray[indexa]= NoiseFloat;
                    indexa++;
                }

                // rumore
                noise = squaremy(NoiseArray);

                // notifica disponibilit campionamento
                semaforo_jTextField.setBackground(java.awt.Color.GREEN);
                semaforo_jTextField.setText("OK");

                // After you get the first frame, collect bytes till the speechStopSize.
                do {
                    numRead =  targetLine.read(data, 0, numBytesToRead);
                    WordByte = display1(data, noise);
                    if (speechFlag ==1)
                    {
                        out.write(data,0,numRead);
                        sourceLine.write(data, 0, numRead);
                    }
                }while(speechArrayIndex <speechStopSize);    // 300 *26 -200


                // Resetting the parameters for the next continuous run...
                speechArrayIndex =0 ;
                speechFlag = 0;
                out.reset();

                sourceLine.drain();

                // notifica impossibilit campionamento
                semaforo_jTextField.setBackground(java.awt.Color.RED);
                semaforo_jTextField.setText("KO");

                // Write the word to a file
                capturedBytes = out.toByteArray();

                ByteArrayInputStream CapturedByteArray = new ByteArrayInputStream(capturedBytes);
                AudioInputStream capturedAudioStream = new AudioInputStream(CapturedByteArray, captureFormat, speechArrayIndex);

                metaTagAudio.CapturedAudioStream = capturedAudioStream;
                metaTagAudio.CapturedBytesLenght = capturedBytes.length;
                metaTagAudio.FrameLength = capturedAudioStream.getFrameLength();
                metaTagAudio.FrameSize = captureFormat.getFrameSize();
                metaTagAudio.FrameRate = captureFormat.getFrameRate();
                metaTagAudio.SampleRate = SampleRate;
                metaTagAudio.NumByteToRead = numBytesToRead;
                metaTagAudio.ByteReaded = WordByte.length;
                metaTagAudio.Noise = noise;
            }
            else{
                WordByte = generateSignal(testFrequence, numBytesTest);
            }

            // creazione pacchetti da nPackage byte per analisi FFT composta
            metaTagAudio.NumPackages = nPackage;
            metaTagAudio.WordByte = WordByte;            
            metaTagAudio.stateHMM = new double[nPackage][nDimension];
            metaTagAudio.nDimension = nDimension;
            metaTagAudio.SignalPackages = new java.util.Vector();
            metaTagAudio.CepstrumPackages = new java.util.Vector();

            int added = 0;
            
            // rilevazione delle caratteristiche del singolo pacchetto
            for(int n=0; n < nPackage; n++){

                float[] _signal = new float[nSamples];
                
                for(int k=0; k<nSamples; k++){
                    _signal[k] = WordByte[k + (n * nSamples)];
                }

                // memorizzo package del segnale
                metaTagAudio.SignalPackages.add(_signal);
               
                // normalizzazione del segnale
                float[] windowedSignal = windowing.apply(_signal);

                // memorizzo cepstrum del segnale
//                float[] cepstrumSignal = cepstrumTransform.doCepstrumTransform(windowedSignal, true);
//
//                // elaborazione cepstrum da gestire per il timbro
//                if(true){
//                    int len = cepstrumSignal.length;
//                    cepstrumSignal[0]=0.0f;
//                    cepstrumSignal[2]=(cepstrumSignal[1]+cepstrumSignal[2]+cepstrumSignal[3]+cepstrumSignal[4])/4.0f;
//                    cepstrumSignal[1]=(cepstrumSignal[0]+cepstrumSignal[1]+cepstrumSignal[3])/3.0f;
//                    cepstrumSignal[0]=(cepstrumSignal[0]+cepstrumSignal[1])/3.0f;
//                    cepstrumSignal[len-3]=(cepstrumSignal[len-2]+cepstrumSignal[len-3]+cepstrumSignal[len-4])/3.0f;
//                    cepstrumSignal[len-2]=(cepstrumSignal[len-1]+cepstrumSignal[len-2]+cepstrumSignal[len-3])/3.0f;
//                    cepstrumSignal[len-1]=(cepstrumSignal[len-1]+cepstrumSignal[len-2])/2.0f;
//                    for (int i=3;i<(len-3);i++){
//                        cepstrumSignal[i] = (cepstrumSignal[i]+cepstrumSignal[i+1]+cepstrumSignal[i-1]+cepstrumSignal[i+2]+cepstrumSignal[i-2]+cepstrumSignal[i+3]+cepstrumSignal[i-3])/7.0f;
//                    }
//                }
//                metaTagAudio.CepstrumPackages.add(cepstrumSignal);    


                // azzera la lista delle dimensioni
                AudioDimension.renew();

                //FFT calcolo
                float[] spectrum = new float [nSamples / 2];
                spectrum = fft.fftMag(windowedSignal);

                // memorizzo le fequenze rilevate FFT
                for(int k=0; k < spectrum.length; k++){

                    // accentuo l'ampiezza del segnale
                    int valueAmpl = Math.round(Math.abs(spectrum[k] * 100));

                    //calcolo della frequenza in relazione con il package in esame
                    int frequence = k * nPackage;

                    if ((frequence >= freqMin) && (valueAmpl >= freqAmplitude)){
                        AudioDimension audioDimension = new AudioDimension(valueAmpl, frequence);
                        AudioDimension.addDimension(audioDimension);
                    }
                }

                // inizializzazione valori frequenze
                float[][] valuesFreq = new float[nDimension][2];


//                for(int k=0; k < cepstrumSignal.length; k++){
//                    // accentuo l'ampiezza del segnale FFT
//                    int valueAmpl = Math.round(Math.abs(cepstrumSignal[k] * 10));
//
//                    //calcolo della frequenza in relazione con il package in esame per CEPSTRUM
//                    int frequence = (k * nPackage) / 2;
//
//                    if ((frequence >= freqMin) && (valueAmpl >= freqAmplitude)){
//                        AudioDimension audioDimension = new AudioDimension(valueAmpl, frequence);
//                        AudioDimension.addDimension(audioDimension);
//                    }
//                }




                // HMM state
                // ordino la lista delle frequenze
                List<AudioDimension> list = AudioDimension.sort();
                
                //memorizzo soltanto il numero di dimensioni richiesto
                int addedDimension = 0;
                for(int k=0; k < list.size(); k++){
                    AudioDimension oAudioDimm = (AudioDimension)list.get(k);

                    // le osservazioni non devono essere a zero
                    if(oAudioDimm.frequence > 0){

                        // nel modello inserisco la frequenza ed il package di appartenenza
                        metaTagAudio.stateHMM[added][addedDimension] = oAudioDimm.frequence;

                        // spectrum associazione ampiezza e spettro della frequenza per la rappresentazione
                        valuesFreq[addedDimension][0] = oAudioDimm.frequence;
                        valuesFreq[addedDimension][1] = oAudioDimm.valueAmpl;

                        addedDimension++;

                        // se ho aggiunto tutte le dimensioni richieste esco dal ciclo for
                        if(addedDimension == nDimension)
                        {
                             break;
                        }
                    }
                }


                metaTagAudio.FFTPackages.add(valuesFreq);

                if(addedDimension > 0)
                {
                    addValueDimensionToPackage(addedDimension, nDimension, metaTagAudio, added, 0);
                    added++;
                }

                // eseguo il campionamento dei soli package necessari
                if(added >= maxPackage){
                    break;
                }
                
            }

            metaTagAudio.addedPackage = added;

            // rilevo se sono state campionati pacchetti di frequenze
            if(added > 0){
                // memorizzo il range della parola campionata
                int topRange = Integer.valueOf(rangesPackages_hashtable.get(added).toString());
                metaTagAudio.topRangesPackages = topRange;

                if((maxPackage == 0) || (maxPackage == nPackage)) maxPackage = topRange;
                // aggiunta delle frequenze a 0 per i pacchetti non valorizzati
                //while(added < nPackage){
                while(added < maxPackage){
                    addValueDimensionToPackage(0, nDimension, metaTagAudio, added, 0);
                    added++;
                }
            }
            else{
                metaTagAudio = null;
            }
        }       
        
        catch (IllegalArgumentException e) { 
            System.err.println(e.getMessage());
        } 
        finally
        {
            return metaTagAudio;
        }
    }

    /***
     *
     * Aggiunge gli zeri per le dimensioni non valorizzate
     *
     * */
    private void addValueDimensionToPackage(int addedDimension, int numDimension, MetaTagAudio metaTagAudio, int addedPackage, int value){

        while(addedDimension < numDimension){
            metaTagAudio.stateHMM[addedPackage][addedDimension] = value;
            addedDimension ++;
        }
    }

    /**
    * 
    * 
    * @param freq   float freq = 3000.0f;
    * @return
    */
    public float[] generateSignal(float freq, int numBytes){
        float ampl = 0.5f;

        float[] values = new float[numBytes];

        float theta = 2.0f * (float) Math.PI * freq / SampleRate;
        for (int i = 0; i < numBytes; i++)
            values[i] = ampl * (float) Math.sin(i*theta);
       
        return values;
   }
    
    /**
     * Arresta una sessione di campionamento
     */
    public void stopSessionSampler(){
        try{
            sourceLine.drain();
            sourceLine.stop();        
            targetLine.stop();
        }
        catch(Exception ex){
        }
        finally{
            sourceLine.close();
            targetLine.close();    
        }
    }   
    
    /**
     * restituisce metatag per parola campionata 
     */
    public MetaTagAudio execute(String word, int freqMin, int freqAmpli, int nSampleRate, int nPackages, int maxPackages, int nDimensions, javax.swing.JTextField semaforo_jTextField){

        MetaTagAudio oMetaTagAudio = execute(0, freqMin, freqAmpli, 0, nSampleRate, nPackages, maxPackages, nDimensions, semaforo_jTextField);

        if(oMetaTagAudio != null) oMetaTagAudio.Word = word;
        
        return oMetaTagAudio;
    }
    
    /**
     * Scrive un file di testo con la campionatura contenuta nel MetaDataAudio;
     */
    public void writeTextFileMetaData(MetaTagAudio metaTag, String filePath) throws IOException
    {
        java.io.FileWriter fileMetaTag = new java.io.FileWriter(filePath + File.separator + metaTag.Word +".txt");
        fileMetaTag.write("[WORD_META_TAG]" + "\n");
        fileMetaTag.write("CapturedBytesLenght = " + metaTag.CapturedBytesLenght + "\n");
        fileMetaTag.write("FrameLength = " + metaTag.FrameLength + "\n");
        fileMetaTag.write("FrameSize = " + metaTag.FrameSize + "\n");
        fileMetaTag.write("FrameRate = " + metaTag.FrameRate + "\n");
        fileMetaTag.write("SampleSet = " + metaTag.SampleSet.toString() + "\n");
        fileMetaTag.write("SampleRate = " + metaTag.SampleRate + "\n");
        fileMetaTag.write("Word = " + metaTag.Word + "\n");
        fileMetaTag.write("Noise = " + metaTag.Noise + "\n");
        fileMetaTag.write("WordByte.lengt = " + metaTag.WordByte.length + "\n");
        fileMetaTag.write("NumByteToRead = " + metaTag.NumByteToRead + "\n");
        fileMetaTag.write("ByteReaded = " + metaTag.ByteReaded + "\n");
        fileMetaTag.write("HMM State = " + metaTag.stateHMM_ToString());
        fileMetaTag.close();
    }
    
    /**
     * Scrive il file audio campionato
     */
    public void writeWaveAudioFile(MetaTagAudio metaTag, String filePath)throws IOException
    {        
        String sFileName = filePath + File.separator + metaTag.Word + ".wav";
        AudioSystem.write(metaTag.CapturedAudioStream, AudioFileFormat.Type.WAVE, new File(sFileName));    
    }
        
    public double squaremy( double[] noiseFrame){
        double sumOfNoise =0;
        double sumOf =0;

        for (int indexb=0;indexb< noiseFrame.length; indexb++){
            sumOfNoise += noiseFrame[indexb];
        }
        sumOf = sumOfNoise/(noiseFrame.length);


        LogWriter.writeLog(Level.FINE, "Rilevato livello di ruomore : " + sumOf);
        return sumOf;
    }  
    
    public double generate(byte[] AudioFrame){
	
        int len=0;
        double noiseVar =0;
        double noiseTotal =0;
        double noiseSum =0;
        double   temp = 0;
        double speechFram =0;
        //double[] speechFram = new double[AudioFrame.length];

        ByteArrayInputStream InByteStream    	= new ByteArrayInputStream(AudioFrame);
        DataInputStream dataInputStream 	= new DataInputStream(InByteStream);

        try {
            for(len=0;len<AudioFrame.length/2; len++){
                temp = (double) dataInputStream.readShort();
                speechFram = temp* 3.0517578125e-5;   //            /Math.pow(2,15);
                noiseVar = speechFram * speechFram;
                noiseTotal += noiseVar;
            }
        }
        catch(IOException e){
            LogWriter.writeLog(Level.SEVERE, "readShort problem");e.printStackTrace();
        }

        noiseSum = noiseTotal/300;
        return noiseSum;
    }
            
    public float[] display1(byte[] AudioByteFrame, double noise ){
        
        double[] speech = new double[AudioByteFrame.length/2];
        //double [] energy= new double[AudioByteFrame.length];
        double speechSum =0;
        int index=0;
        int index1=0;
        double speechtemp;

        // Calculate the sum of energy in the given frame.
        speechSum = generate(AudioByteFrame);

        ByteArrayInputStream ByteStream = new ByteArrayInputStream(AudioByteFrame);
        DataInputStream dataStream 	= new DataInputStream(ByteStream);

        try {
            for (index1 = 0; index1<AudioByteFrame.length/2; index1++){
                speechtemp = (double) dataStream.readShort();
                speech[index1] = speechtemp * 3.0517578125e-5;
            }
        }
        catch (IOException e){
            LogWriter.writeLog(Level.SEVERE, "readShort problem");e.printStackTrace();
        }

        double noiseRound = 50 * noise;

//        System.out.println("Soglia del Rumore: " + noiseRound);
//        System.out.println("Parlato : " + speechSum);

        if (speechSum > noiseRound){

            if( speechFlag == 0){

                speechtemp =0;

                for( index=0;index<AudioByteFrame.length/2;index++,speechArrayIndex++){
                    speechArray [speechArrayIndex] = (float)speech[index];
                }

                speechFlag = 1;
                return 	speechArray;
            }
        }

        if (speechFlag == 1){
            if (speechArrayIndex < speechStopSize){
                //System.out.println("buffering ..." + speechArrayIndex);
                speechtemp =0;
                for(index=0;index<AudioByteFrame.length/2;index++,speechArrayIndex++){
                    speechArray [speechArrayIndex] = (float)speech[index];
                }
            }
            return speechArray;
        }
        else{
            if (noiseIndex<= 300){
                noiseMoving = noiseMoving + (speechSum / 301);
                noiseIndex ++;
            }
            else if( noiseIndex > 300){
                LogWriter.writeLog(Level.FINE, "Valore iniziale del rumore: " + noise);
                noise = noiseMoving;
                LogWriter.writeLog(Level.FINE, "Valore attuale del rumore: " + noiseMoving);
                noiseIndex=0;
                noiseMoving =0;
            }
            return speechArray;
        }
     }    
    
}
