/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SamplerJFrame.java
 *
 * Created on 7-apr-2009, 14.49.32
 */

package romas.services.speakrecognition;

import romas.com.data.hmm.HMM_Manager;
import java.awt.Color;
import javax.swing.*;
import javax.swing.table.*;
import romas.util.io.SafeOverwriteFileChooser;
import romas.com.data.Configuration;
import java.io.File;

/**
 *
 * @author apaliani
 */
public class SamplerJFrame extends JFrame {

    Spectrum spectrum = null;
    SamplerManager samplerManager = null;
    Thread samplerThread = null;
    volatile boolean samplerThreadIsRunning = false;
    static SamplerJFrame samplerJFrame = null;


    /** Creates new form SamplerJFrame */
    public SamplerJFrame() {
        initComponents();

        String USER_DIR_KEY = "user.dir";
        String currentDir = System.getProperty(USER_DIR_KEY);

        // lettura configurazione del campionatore
        loadConfiguration(currentDir + File.separator + "config" + File.separator + "romas_sampler.properties");


        String hmmDir = currentDir + File.separator + "hmm" + File.separator + "speech";
        modelsHMM_dir_jTextField.setText(hmmDir);

        int nSampleRate = Integer.valueOf(nSampleRate_textField.getText());
        int nPackages = Integer.valueOf(nPackages_textField.getText());

        spectrum = new Spectrum(nPackages, nSampleRate);
        samplerManager = new SamplerManager();
        //samplerManager.setup();
        //main_jSplitPane.getLeftComponent().setSize(800, 600);
        main_jSplitPane.getLeftComponent().setSize(main_jSplitPane.getWidth() - 100, 800);
        main_jSplitPane.setLeftComponent(spectrum);
        main_jSplitPane.setDividerLocation(main_jSplitPane.getWidth() - 100);
    }

    
    private void loadConfiguration(String fileName){
        try{
            File file = new File(fileName);
            if(file.exists()){
                Configuration config = new Configuration();
                config.loadPropertiesFile(fileName);
                nSampleRate_textField.setText(config.getPropertiesValue("sample_rate"));
                nPackages_textField.setText(config.getPropertiesValue("n_packages"));
                nSamples_textField.setText(String.valueOf(calcNSamples()));
                freqMin_jTextField.setText(config.getPropertiesValue("freq_min"));
                freqAmpliMin_jTextField.setText(config.getPropertiesValue("freq_ampl_min"));
                sequenze_jTextField.setText(config.getPropertiesValue("n_sequence"));
                dimensioni_jTextField.setText(config.getPropertiesValue("n_dimensions"));
                threshold_jTextField.setText(config.getPropertiesValue("recognition_threshold"));
            }
        }
        catch(Exception ex){
            System.err.println("Errore in lettura file di configurazione sampler_romas.properties. Error: " + ex.getMessage());
        }    
    }



    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        main_jToolBar = new javax.swing.JToolBar();
        main_jSplitPane = new javax.swing.JSplitPane();
        paramsSamplerjPanel = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        word_jTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        dimensioni_jTextField = new javax.swing.JTextField();
        sequenze_jTextField = new javax.swing.JTextField();
        jToolBar1 = new javax.swing.JToolBar();
        sampler_jButton = new javax.swing.JButton();
        recognizer_jButton = new javax.swing.JButton();
        hmmBuilder_jButton = new javax.swing.JButton();
        training_jButton = new javax.swing.JButton();
        saveConfiguration_jButton = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        threshold_jTextField = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        campionamenti_jProgressBar = new javax.swing.JProgressBar();
        semaforo_jTextField = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        perc_recogn_viterbi_jTextField = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        sequences_jTable = new javax.swing.JTable();
        jToolBar2 = new javax.swing.JToolBar();
        jLabel2 = new javax.swing.JLabel();
        nSampleRate_textField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        nPackages_textField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        nSamples_textField = new javax.swing.JTextField();
        jToolBar3 = new javax.swing.JToolBar();
        jLabel5 = new javax.swing.JLabel();
        testFreq_jTextField = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        testFreq_Byte_jTextField = new javax.swing.JTextField();
        testFreq_jButton = new javax.swing.JButton();
        jLabel15 = new javax.swing.JLabel();
        freqMin_jTextField = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        freqAmpliMin_jTextField = new javax.swing.JTextField();
        modelsHMM_dir_jTextField = new javax.swing.JTextField();
        jLabel17 = new javax.swing.JLabel();
        select_HMMdit_jButton = new javax.swing.JButton();
        perc_recogn_jTextField = new javax.swing.JTextField();
        jLabel18 = new javax.swing.JLabel();
        distance_jTextField = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        pacchetti_jTextField = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        range_pacchetti_jTextField = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Ro.Ma.S. - SR - Campionatore v. 0.9.1");
        getContentPane().setLayout(new java.awt.GridLayout(1, 0));

        main_jToolBar.setFloatable(false);
        main_jToolBar.setRollover(true);
        main_jToolBar.setOpaque(false);

        main_jSplitPane.setMaximumSize(null);
        main_jSplitPane.setMinimumSize(new java.awt.Dimension(300, 400));
        main_jSplitPane.setPreferredSize(new java.awt.Dimension(300, 400));

        paramsSamplerjPanel.setMaximumSize(new java.awt.Dimension(300, 451));
        paramsSamplerjPanel.setMinimumSize(new java.awt.Dimension(300, 451));
        paramsSamplerjPanel.setPreferredSize(new java.awt.Dimension(300, 200));

        jLabel4.setText("Parola esaminata");

        word_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        jLabel6.setText("N dimensioni ");

        jLabel7.setText("N di sequenze");

        dimensioni_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        dimensioni_jTextField.setText("5");
        dimensioni_jTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dimensioni_jTextFieldActionPerformed(evt);
            }
        });

        sequenze_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        sequenze_jTextField.setText("10");

        sampler_jButton.setText("Campiona");
        sampler_jButton.setActionCommand("sampler_start");
        sampler_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sampler_jButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(sampler_jButton);

        recognizer_jButton.setText("Confronta");
        recognizer_jButton.setActionCommand("recognizer_start");
        recognizer_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                recognizer_jButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(recognizer_jButton);

        hmmBuilder_jButton.setText("Genera HMM");
        hmmBuilder_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hmmBuilder_jButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(hmmBuilder_jButton);

        training_jButton.setText("Addestra");
        training_jButton.setActionCommand("training_start");
        training_jButton.setFocusable(false);
        training_jButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        training_jButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        training_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                training_jButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(training_jButton);

        saveConfiguration_jButton.setText("Salva configurazione");
        saveConfiguration_jButton.setFocusable(false);
        saveConfiguration_jButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        saveConfiguration_jButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        saveConfiguration_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveConfiguration_jButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(saveConfiguration_jButton);

        jLabel8.setText("Soglia");

        threshold_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        threshold_jTextField.setText("30");

        jLabel9.setText("%");

        jLabel11.setText("Stato campionatore");

        campionamenti_jProgressBar.setString("0");
        campionamenti_jProgressBar.setStringPainted(true);

        semaforo_jTextField.setBackground(java.awt.Color.red);
        semaforo_jTextField.setEditable(false);
        semaforo_jTextField.setFont(new java.awt.Font("Tahoma", 1, 11));
        semaforo_jTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        semaforo_jTextField.setText("KO");

        jLabel12.setText("% riconosciuta");

        perc_recogn_viterbi_jTextField.setFont(new java.awt.Font("Tahoma", 1, 11));
        perc_recogn_viterbi_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        perc_recogn_viterbi_jTextField.setText("0");
        perc_recogn_viterbi_jTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                perc_recogn_viterbi_jTextFieldActionPerformed(evt);
            }
        });

        jLabel13.setText("%");

        jLabel14.setText("sequenze");

        sequences_jTable.setColumnSelectionAllowed(true);
        jScrollPane2.setViewportView(sequences_jTable);

        jToolBar2.setRollover(true);

        jLabel2.setText("Sample rate");
        jToolBar2.add(jLabel2);

        nSampleRate_textField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nSampleRate_textField.setText("10240");
        nSampleRate_textField.setAutoscrolls(false);
        nSampleRate_textField.setMaximumSize(new java.awt.Dimension(60, 20));
        nSampleRate_textField.setMinimumSize(new java.awt.Dimension(60, 20));
        nSampleRate_textField.setName(""); // NOI18N
        nSampleRate_textField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nSampleRate_textFieldActionPerformed(evt);
            }
        });
        nSampleRate_textField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                nSampleRate_textFieldKeyReleased(evt);
            }
        });
        jToolBar2.add(nSampleRate_textField);

        jLabel1.setText("Numero pacchetti");
        jToolBar2.add(jLabel1);

        nPackages_textField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nPackages_textField.setText("40");
        nPackages_textField.setAutoscrolls(false);
        nPackages_textField.setMaximumSize(new java.awt.Dimension(60, 20));
        nPackages_textField.setMinimumSize(new java.awt.Dimension(60, 20));
        nPackages_textField.setName(""); // NOI18N
        nPackages_textField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                nPackages_textFieldKeyReleased(evt);
            }
        });
        jToolBar2.add(nPackages_textField);

        jLabel3.setText("Byte per pacchetto");
        jToolBar2.add(jLabel3);

        nSamples_textField.setEditable(false);
        nSamples_textField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nSamples_textField.setText("256");
        nSamples_textField.setAutoscrolls(false);
        nSamples_textField.setMaximumSize(new java.awt.Dimension(60, 19));
        nSamples_textField.setMinimumSize(new java.awt.Dimension(60, 19));
        nSamples_textField.setName(""); // NOI18N
        nSamples_textField.setOpaque(false);
        jToolBar2.add(nSamples_textField);

        jToolBar3.setRollover(true);

        jLabel5.setText("Freq.");
        jToolBar3.add(jLabel5);

        testFreq_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        testFreq_jTextField.setText("300");
        testFreq_jTextField.setMaximumSize(new java.awt.Dimension(60, 20));
        testFreq_jTextField.setMinimumSize(new java.awt.Dimension(60, 20));
        testFreq_jTextField.setPreferredSize(new java.awt.Dimension(60, 20));
        testFreq_jTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testFreq_jTextFieldActionPerformed(evt);
            }
        });
        jToolBar3.add(testFreq_jTextField);

        jLabel10.setText("byte");
        jToolBar3.add(jLabel10);

        testFreq_Byte_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        testFreq_Byte_jTextField.setText("516");
        testFreq_Byte_jTextField.setMaximumSize(new java.awt.Dimension(60, 20));
        testFreq_Byte_jTextField.setMinimumSize(new java.awt.Dimension(60, 20));
        testFreq_Byte_jTextField.setPreferredSize(new java.awt.Dimension(60, 20));
        testFreq_Byte_jTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testFreq_Byte_jTextFieldActionPerformed(evt);
            }
        });
        jToolBar3.add(testFreq_Byte_jTextField);

        testFreq_jButton.setText("Test freq.");
        testFreq_jButton.setActionCommand("testFrequence_start");
        testFreq_jButton.setFocusable(false);
        testFreq_jButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        testFreq_jButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        testFreq_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testFreq_jButtonActionPerformed(evt);
            }
        });
        jToolBar3.add(testFreq_jButton);

        jLabel15.setText("Freq. min.");

        freqMin_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        freqMin_jTextField.setText("300");
        freqMin_jTextField.setMaximumSize(new java.awt.Dimension(60, 20));
        freqMin_jTextField.setMinimumSize(new java.awt.Dimension(60, 20));
        freqMin_jTextField.setPreferredSize(new java.awt.Dimension(60, 20));
        freqMin_jTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                freqMin_jTextFieldActionPerformed(evt);
            }
        });

        jLabel16.setText("Ampiezza minima");

        freqAmpliMin_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        freqAmpliMin_jTextField.setText("1");
        freqAmpliMin_jTextField.setMaximumSize(new java.awt.Dimension(60, 20));
        freqAmpliMin_jTextField.setMinimumSize(new java.awt.Dimension(60, 20));
        freqAmpliMin_jTextField.setPreferredSize(new java.awt.Dimension(60, 20));
        freqAmpliMin_jTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                freqAmpliMin_jTextFieldActionPerformed(evt);
            }
        });

        modelsHMM_dir_jTextField.setEditable(false);

        jLabel17.setText("Directory hmm");

        select_HMMdit_jButton.setText("seleziona ...");
        select_HMMdit_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                select_HMMdit_jButtonActionPerformed(evt);
            }
        });

        perc_recogn_jTextField.setFont(new java.awt.Font("Tahoma", 1, 11));
        perc_recogn_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        perc_recogn_jTextField.setText("0");

        jLabel18.setText("Distanza");

        distance_jTextField.setFont(new java.awt.Font("Tahoma", 1, 11));
        distance_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        distance_jTextField.setText("0");

        jLabel19.setText("pacchetti valorizzati");

        pacchetti_jTextField.setFont(new java.awt.Font("Tahoma", 1, 11));
        pacchetti_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        pacchetti_jTextField.setText("0");

        jLabel20.setText("range pacchetti");

        range_pacchetti_jTextField.setFont(new java.awt.Font("Tahoma", 1, 11));
        range_pacchetti_jTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        range_pacchetti_jTextField.setText("0");

        org.jdesktop.layout.GroupLayout paramsSamplerjPanelLayout = new org.jdesktop.layout.GroupLayout(paramsSamplerjPanel);
        paramsSamplerjPanel.setLayout(paramsSamplerjPanelLayout);
        paramsSamplerjPanelLayout.setHorizontalGroup(
            paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(paramsSamplerjPanelLayout.createSequentialGroup()
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, paramsSamplerjPanelLayout.createSequentialGroup()
                                .add(jToolBar2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 426, Short.MAX_VALUE)
                                .add(98, 98, 98))
                            .add(paramsSamplerjPanelLayout.createSequentialGroup()
                                .addContainerGap()
                                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                    .add(org.jdesktop.layout.GroupLayout.LEADING, paramsSamplerjPanelLayout.createSequentialGroup()
                                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(jLabel7)
                                            .add(jLabel6))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(dimensioni_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(sequenze_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(jLabel12)
                                            .add(jLabel8))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(threshold_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                                .add(perc_recogn_viterbi_jTextField)
                                                .add(distance_jTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 29, Short.MAX_VALUE)))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                            .add(paramsSamplerjPanelLayout.createSequentialGroup()
                                                .add(jLabel9)
                                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                                .add(perc_recogn_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 34, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                            .add(jLabel13))
                                        .add(18, 18, 18)))))
                        .add(11, 11, 11))
                    .add(jToolBar3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 268, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 458, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(paramsSamplerjPanelLayout.createSequentialGroup()
                                    .add(jLabel11)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(semaforo_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 94, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(paramsSamplerjPanelLayout.createSequentialGroup()
                                    .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(jLabel4)
                                        .add(jLabel17))
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                        .add(word_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 114, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(paramsSamplerjPanelLayout.createSequentialGroup()
                                            .add(modelsHMM_dir_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 231, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                            .add(select_HMMdit_jButton)))))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, paramsSamplerjPanelLayout.createSequentialGroup()
                                .add(jLabel15)
                                .add(18, 18, 18)
                                .add(freqMin_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(jLabel16)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(freqAmpliMin_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 35, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel18))
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(jLabel19)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(pacchetti_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(jLabel20)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(range_pacchetti_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, paramsSamplerjPanelLayout.createSequentialGroup()
                                .add(jLabel14)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(campionamenti_jProgressBar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 282, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        paramsSamplerjPanelLayout.setVerticalGroup(
            paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(paramsSamplerjPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jToolBar2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jToolBar3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jLabel15)
                    .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel16)
                        .add(freqAmpliMin_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(freqMin_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel11)
                    .add(semaforo_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(word_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(modelsHMM_dir_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel17)
                    .add(select_HMMdit_jButton))
                .add(12, 12, 12)
                .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel7, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                            .add(sequenze_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(dimensioni_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel6))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel8)
                            .add(threshold_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel12)
                            .add(perc_recogn_viterbi_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(paramsSamplerjPanelLayout.createSequentialGroup()
                        .add(jLabel13)
                        .add(15, 15, 15)
                        .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel9)
                            .add(perc_recogn_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel18)
                    .add(distance_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(campionamenti_jProgressBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel14))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(paramsSamplerjPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel19)
                    .add(pacchetti_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel20)
                    .add(range_pacchetti_jTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 88, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(23, 23, 23))
        );

        main_jSplitPane.setRightComponent(paramsSamplerjPanel);

        main_jToolBar.add(main_jSplitPane);

        getContentPane().add(main_jToolBar);

        pack();
    }// </editor-fold>//GEN-END:initComponents
/***/
    private void sampler_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sampler_jButtonActionPerformed
        // TODO add your handling code here:
        try{
            campionamenti_jProgressBar.setString("0");
            campionamenti_jProgressBar.setValue(0);            
            semaforo_jTextField.setBackground(java.awt.Color.RED);
            semaforo_jTextField.setText("KO");
            perc_recogn_jTextField.setBackground(Color.RED);
            perc_recogn_jTextField.setText("0");
            range_pacchetti_jTextField.setText(nPackages_textField.getText());

            if(evt.getActionCommand().equals("sampler_start")){

                //SwingUtilities.invokeAndWait(new Runnable() {
                samplerThread = new Thread(){
                    public void run(){
                        int seq = 0;
                        int sequenze = Integer.valueOf(sequenze_jTextField.getText());
                        int nSampleRate = Integer.valueOf(nSampleRate_textField.getText());
                        int nPackages = Integer.valueOf(nPackages_textField.getText());
                        int nDimension = Integer.valueOf(dimensioni_jTextField.getText());
                        int freqMin = Integer.valueOf(freqMin_jTextField.getText());
                        int freqAmpliMin = Integer.valueOf(freqAmpliMin_jTextField.getText());
                        int nMaxPackages = nPackages;
                        
                        range_pacchetti_jTextField.setText("" + nMaxPackages);

                        campionamenti_jProgressBar.setMaximum(sequenze);
                        campionamenti_jProgressBar.setMinimum(0);

                        // cancellazione file training
                        HMM_Manager.deleteFileTraining(modelsHMM_dir_jTextField.getText() + File.separator  + word_jTextField.getText() + ".training");

                        //setTitleTable();

                        samplerManager.setup();
                        samplerManager.initSessionSampler();
                        boolean doBeginSampler = true;
                        do{
                            MetaTagAudio samplerAudio = samplerManager.executeSampler(word_jTextField.getText(), freqMin, freqAmpliMin, nSampleRate, nPackages, nMaxPackages, nDimension, semaforo_jTextField);
                            if(samplerAudio != null){

                                if(doBeginSampler) {
                                    nMaxPackages = samplerAudio.topRangesPackages;
                                    range_pacchetti_jTextField.setText("" + samplerAudio.topRangesPackages);
                                    doBeginSampler = false;
                                }

                                if(samplerAudio.topRangesPackages == nMaxPackages){
                                    spectrum.paintSampler(samplerAudio);
                                    String fileName = modelsHMM_dir_jTextField.getText() + File.separator  + word_jTextField.getText();
                                    samplerManager.setSamplerToFile(fileName, samplerAudio, nDimension, sequenze);
                                    seq++;
                                    campionamenti_jProgressBar.setValue(seq);
                                    campionamenti_jProgressBar.setString(seq + " / " + sequenze);
                                    campionamenti_jProgressBar.setToolTipText("numero campionamenti: " + seq);
                                    pacchetti_jTextField.setText("" + samplerAudio.addedPackage);
                                }
                            }
                        }while((seq < sequenze) && samplerThreadIsRunning);

                        samplerThreadIsRunning = false;
                        samplerManager.stopSessionSampler();                        
                        recognizer_jButton.setEnabled(true);
                        hmmBuilder_jButton.setEnabled(true);
                        training_jButton.setEnabled(true);
                        sampler_jButton.setActionCommand("sampler_start");
                        sampler_jButton.setText("Campiona");
                    }
                };

                if(!samplerThreadIsRunning){
                    samplerThreadIsRunning = true;
                    samplerThread.start();
                    recognizer_jButton.setEnabled(false);
                    hmmBuilder_jButton.setEnabled(false);
                    training_jButton.setEnabled(false);
                    sampler_jButton.setActionCommand("sampler_stop");
                    sampler_jButton.setText("Arresta");
                }
                else{
                    JOptionPane.showMessageDialog((JFrame)samplerJFrame, "Campionatore occupato !");
                }
            }

            if(evt.getActionCommand().equals("sampler_stop")){
                samplerThreadIsRunning = false;
                samplerThread.interrupt();
                samplerThread = null;
                
                recognizer_jButton.setEnabled(true);
                hmmBuilder_jButton.setEnabled(true);
                training_jButton.setEnabled(true);
                sampler_jButton.setActionCommand("sampler_start");
                sampler_jButton.setText("Campiona");
            }

        }catch(Exception ex){
            System.err.println(ex.getMessage());
        }
}//GEN-LAST:event_sampler_jButtonActionPerformed


    private void setTitleTable(){
        int nPackages = Integer.valueOf(nPackages_textField.getText());
        TableColumnModel columns = sequences_jTable.getColumnModel();
        int colCount = sequences_jTable.getColumnCount();
        if(nPackages > colCount){
            for(int i=0; i<(nPackages - colCount); i++){
                TableColumn col = new TableColumn(columns.getColumnCount());
                sequences_jTable.addColumn(col);
            }
        }

        sequences_jTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

        for(int i=0; i<nPackages; i++){
            TableColumn col = columns.getColumn(i);
            col.setHeaderValue("pk_" + (i +1));            
        }
    }


    public void addSequenceRow(double[][] stateFFT) {
        DefaultTableModel model = (DefaultTableModel)sequences_jTable.getModel();
        // scorro le osservazioni degli stati
        java.util.Vector rowData = new java.util.Vector();
        for(int i=0; i< stateFFT.length; i++){
            // scorro le dimensioni
            String valuesPackage = "";
            for(int j=0; j<stateFFT[i].length; j++){
                valuesPackage += String.valueOf(stateFFT[i][j] + ", ");
            }
            rowData.add(valuesPackage);
        }
        model.addRow(rowData);
    }


    private void testFreq_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testFreq_jButtonActionPerformed
        // TODO add your handling code here:
        try{
            semaforo_jTextField.setBackground(java.awt.Color.RED);
            semaforo_jTextField.setText("KO");

            if(evt.getActionCommand().equals("testFrequence_start")){
                float testFreq = Float.valueOf(testFreq_jTextField.getText()).floatValue();

                int nSampleRate = Integer.valueOf(nSampleRate_textField.getText());
                int nPackages = Integer.valueOf(nPackages_textField.getText());
                int numBytes = Integer.valueOf(testFreq_Byte_jTextField.getText());
                int nDimension = Integer.valueOf(dimensioni_jTextField.getText());
                int freqMin = Integer.valueOf(freqMin_jTextField.getText());
                int freqAmpliMin = Integer.valueOf(freqAmpliMin_jTextField.getText());


                spectrum.executeTest(testFreq, numBytes, nSampleRate, freqMin, freqAmpliMin, nPackages, nDimension, semaforo_jTextField);
            }
        }catch(Exception ex){
            System.err.println(ex.getMessage());
        }

}//GEN-LAST:event_testFreq_jButtonActionPerformed

    private void testFreq_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testFreq_jTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_testFreq_jTextFieldActionPerformed

    private void hmmBuilder_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hmmBuilder_jButtonActionPerformed
        // TODO add your handling code here:
        try{
            sampler_jButton.setEnabled(false);
            recognizer_jButton.setEnabled(false);
            int state = Integer.valueOf(range_pacchetti_jTextField.getText());
            String pathFiles = modelsHMM_dir_jTextField.getText() + File.separator + word_jTextField.getText();
            HMM_Manager.trainingToHMM(pathFiles + ".training", pathFiles + ".hmm", state, 5);

            // creo una relazione tra la parola ed il numero di pacchetti campionato
            String fileName_WordPackages = modelsHMM_dir_jTextField.getText() + File.separator + "WordPackages.properties";
            Configuration configWordPackages = new Configuration();
            configWordPackages.loadPropertiesFile(fileName_WordPackages);
            configWordPackages.putPropertiesValue(word_jTextField.getText(), String.valueOf(state));
            configWordPackages.storePropertiesFile(fileName_WordPackages);

            JOptionPane.showMessageDialog((JFrame)samplerJFrame, "Creato modello: " + pathFiles + ".hmm");
            sampler_jButton.setEnabled(true);
            recognizer_jButton.setEnabled(true);
        }
        catch(Exception ex){
            System.err.println(ex.getMessage());
        }
    }//GEN-LAST:event_hmmBuilder_jButtonActionPerformed

    private void recognizer_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_recognizer_jButtonActionPerformed
        // TODO add your handling code here:
        try{
            semaforo_jTextField.setText("KO");
            semaforo_jTextField.setBackground(java.awt.Color.RED);
            perc_recogn_jTextField.setBackground(Color.RED);
            perc_recogn_jTextField.setText("0");
            pacchetti_jTextField.setText("0");

            if(evt.getActionCommand().equals("recognizer_start")){
                samplerThread = new Thread(){
                //SwingUtilities.invokeAndWait(new Runnable() {
                    public void run(){
                        int nSampleRate = Integer.valueOf(nSampleRate_textField.getText());
                        int nPackages = Integer.valueOf(nPackages_textField.getText());
                        int nDimension = Integer.valueOf(dimensioni_jTextField.getText());
                        double level = Double.valueOf(threshold_jTextField.getText()).doubleValue();
                        int freqMin = Integer.valueOf(freqMin_jTextField.getText());
                        int freqAmpliMin = Integer.valueOf(freqAmpliMin_jTextField.getText());
                        int nMaxPackages = Integer.valueOf(nPackages_textField.getText());

                        range_pacchetti_jTextField.setText("" + nMaxPackages);

                        //if(nMaxPackages == 0) nMaxPackages = nPackages;
                        //setTitleTable();

                        samplerManager.setup();
                        samplerManager.initSessionSampler();
                        
                        while(samplerThreadIsRunning){
                            Object[] results = new Object[2];

                            results = samplerManager.recognize(word_jTextField.getText(), modelsHMM_dir_jTextField.getText(), nDimension, freqMin, freqAmpliMin, nSampleRate, nPackages, nMaxPackages, semaforo_jTextField);
                            
                            if(results[1] != null){
                                MetaTagAudio samplerAudio = (MetaTagAudio)results[1];
                                // stampo il grafico della parola campionata
                                spectrum.paintSampler(samplerAudio);
                                pacchetti_jTextField.setText("" + samplerAudio.addedPackage);
                                //if((nMaxPackages == 0) || (nMaxPackages == nPackages)) nMaxPackages = samplerAudio.topRangesPackages;
                                range_pacchetti_jTextField.setText("" + samplerAudio.topRangesPackages);
                            }
                            else{
                                range_pacchetti_jTextField.setText("0");
                                pacchetti_jTextField.setText("0");
                            }

                            double perc_rec = 0;
                            double perc_rec_viterbi = 0;
                            double distance = -1;

                            // verifico se i pacchetti della parola campionata sono confrontabili
                            Configuration configWordPackages = new Configuration();
                            configWordPackages.loadPropertiesFile(modelsHMM_dir_jTextField.getText() + File.separator + "WordPackages.properties");                            
                            int wordPackages = Integer.valueOf(configWordPackages.getPropertiesValue(word_jTextField.getText()));
                            
                            if(wordPackages == Integer.valueOf(range_pacchetti_jTextField.getText()).intValue()){
                                if(results[0] != null) perc_rec = Double.valueOf(results[0].toString());
                                if(results[2] != null) perc_rec_viterbi = Double.valueOf(results[2].toString());
                                if(results[3] != null) distance = Double.valueOf(results[3].toString());
                            }

                            perc_recogn_jTextField.setText("" + perc_rec);
                            perc_recogn_viterbi_jTextField.setText("" + perc_rec_viterbi);
                            distance_jTextField.setText("" + distance);

                            if(perc_rec > level){
                                perc_recogn_jTextField.setBackground(Color.GREEN);
                            }else{
                                perc_recogn_jTextField.setBackground(Color.RED);
                            }

                            if(perc_rec_viterbi > level){
                                perc_recogn_viterbi_jTextField.setBackground(Color.GREEN);
                            }else{
                                perc_recogn_viterbi_jTextField.setBackground(Color.RED);
                            }

                            if(distance > -1){
                                distance_jTextField.setBackground(Color.GREEN);
                            }else{
                                distance_jTextField.setBackground(Color.RED);
                            }
                        }
                        samplerManager.stopSessionSampler();
                    }
                };

                if(!samplerThreadIsRunning){
                    samplerThreadIsRunning = true;
                    samplerThread.start();
                    sampler_jButton.setEnabled(false);
                    training_jButton.setEnabled(false);
                    hmmBuilder_jButton.setEnabled(false);
                    recognizer_jButton.setActionCommand("recognizer_stop");
                    recognizer_jButton.setText("Arresta");
                }
                else{
                    JOptionPane.showMessageDialog((JFrame)samplerJFrame, "Campionatore occupato !");
                }
            }

            if(evt.getActionCommand().equals("recognizer_stop")){                
                samplerThreadIsRunning = false;
                
                sampler_jButton.setEnabled(true);
                hmmBuilder_jButton.setEnabled(true);
                training_jButton.setEnabled(true);
                recognizer_jButton.setActionCommand("recognizer_start");
                recognizer_jButton.setText("Confronta");                
            }

        }catch(Exception ex){
            System.err.println(ex.getMessage());
        }

    }//GEN-LAST:event_recognizer_jButtonActionPerformed

    private int calcNSamples(){    
        try{
            int nSampleRate = Integer.parseInt(nSampleRate_textField.getText());
            int nPackages = Integer.parseInt(nPackages_textField.getText());    
            return (nSampleRate / nPackages);
        }
        catch(Exception ex){            
        }
        return 0;
    }

    private void nSampleRate_textFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_nSampleRate_textFieldKeyReleased
        // TODO add your handling code here:
        nSamples_textField.setText(String.valueOf(calcNSamples()));                        
    }//GEN-LAST:event_nSampleRate_textFieldKeyReleased

    private void nSampleRate_textFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nSampleRate_textFieldActionPerformed
        // TODO add your handling code here:

    }//GEN-LAST:event_nSampleRate_textFieldActionPerformed

    private void nPackages_textFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_nPackages_textFieldKeyReleased
        // TODO add your handling code here:
        nSamples_textField.setText(String.valueOf(calcNSamples()));
    }//GEN-LAST:event_nPackages_textFieldKeyReleased

    private void testFreq_Byte_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testFreq_Byte_jTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_testFreq_Byte_jTextFieldActionPerformed

    private void perc_recogn_viterbi_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_perc_recogn_viterbi_jTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_perc_recogn_viterbi_jTextFieldActionPerformed

    private void dimensioni_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dimensioni_jTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_dimensioni_jTextFieldActionPerformed

    private void freqMin_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_freqMin_jTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_freqMin_jTextFieldActionPerformed

    private void freqAmpliMin_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_freqAmpliMin_jTextFieldActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_freqAmpliMin_jTextFieldActionPerformed

    private void saveConfiguration_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveConfiguration_jButtonActionPerformed
        // TODO add your handling code here:

        JFileChooser chooser = new SafeOverwriteFileChooser();
        String USER_DIR_KEY = "user.dir";
        String currentDir = System.getProperty(USER_DIR_KEY);
        chooser.setCurrentDirectory(new File(currentDir + File.separator + "config"));
        chooser.showSaveDialog(null);
        String sFileName = chooser.getCurrentDirectory().getPath() + File.separator + chooser.getName(chooser.getSelectedFile());


        Configuration config = new Configuration();

        config.putPropertiesValue("sample_rate", nSampleRate_textField.getText());
        config.putPropertiesValue("n_packages", nPackages_textField.getText());
        config.putPropertiesValue("freq_min", freqMin_jTextField.getText());
        config.putPropertiesValue("freq_ampl_min", freqAmpliMin_jTextField.getText());
        config.putPropertiesValue("n_sequence", sequenze_jTextField.getText());
        config.putPropertiesValue("n_dimensions", dimensioni_jTextField.getText());
        config.putPropertiesValue("recognition_threshold", threshold_jTextField.getText());

        config.storePropertiesFile(sFileName);

        JOptionPane.showMessageDialog((JFrame)samplerJFrame, "Configurazione salvata in : " + sFileName);
    }//GEN-LAST:event_saveConfiguration_jButtonActionPerformed

    private void training_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_training_jButtonActionPerformed
}//GEN-LAST:event_training_jButtonActionPerformed

    private void select_HMMdit_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_select_HMMdit_jButtonActionPerformed
        // TODO add your handling code here:

        JFileChooser chooser = new SafeOverwriteFileChooser();
        try{
            chooser.setCurrentDirectory(new File(modelsHMM_dir_jTextField.getText()));
        }catch(Exception ex){}
        
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        chooser.showOpenDialog(null);

        String sDirName = chooser.getCurrentDirectory().getPath() + File.separator + chooser.getName(chooser.getSelectedFile());
        modelsHMM_dir_jTextField.setText(sDirName);
    }//GEN-LAST:event_select_HMMdit_jButtonActionPerformed


    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                samplerJFrame = new SamplerJFrame();
                samplerJFrame.setSize(1024, 768);
                samplerJFrame.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JProgressBar campionamenti_jProgressBar;
    private javax.swing.JTextField dimensioni_jTextField;
    private javax.swing.JTextField distance_jTextField;
    private javax.swing.JTextField freqAmpliMin_jTextField;
    private javax.swing.JTextField freqMin_jTextField;
    private javax.swing.JButton hmmBuilder_jButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JToolBar jToolBar2;
    private javax.swing.JToolBar jToolBar3;
    private javax.swing.JSplitPane main_jSplitPane;
    private javax.swing.JToolBar main_jToolBar;
    private javax.swing.JTextField modelsHMM_dir_jTextField;
    private javax.swing.JTextField nPackages_textField;
    private javax.swing.JTextField nSampleRate_textField;
    private javax.swing.JTextField nSamples_textField;
    private javax.swing.JTextField pacchetti_jTextField;
    private javax.swing.JPanel paramsSamplerjPanel;
    private javax.swing.JTextField perc_recogn_jTextField;
    private javax.swing.JTextField perc_recogn_viterbi_jTextField;
    private javax.swing.JTextField range_pacchetti_jTextField;
    private javax.swing.JButton recognizer_jButton;
    private javax.swing.JButton sampler_jButton;
    private javax.swing.JButton saveConfiguration_jButton;
    private javax.swing.JButton select_HMMdit_jButton;
    private javax.swing.JTextField semaforo_jTextField;
    private javax.swing.JTable sequences_jTable;
    private javax.swing.JTextField sequenze_jTextField;
    private javax.swing.JTextField testFreq_Byte_jTextField;
    private javax.swing.JButton testFreq_jButton;
    private javax.swing.JTextField testFreq_jTextField;
    private javax.swing.JTextField threshold_jTextField;
    private javax.swing.JButton training_jButton;
    private javax.swing.JTextField word_jTextField;
    // End of variables declaration//GEN-END:variables

}
