/*
 * Spectrum.java
 *
 * Created on 24 febbraio 2009, 12.01
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.services.speakrecognition;

/**
 *
 * @author APaliani
 */
import java.awt.*;
import java.awt.event.WindowEvent;
import javax.swing.*;
import romas.com.data.hmm.*;


/**
 *
 * @author paliani
 */
public class Spectrum extends JComponent{
    
    int x0 = 0;
    int y0 = 0;
    int nSampleRate = 10240; //8192;// 10240; //16384; //32768; // 43008;
    int nPackages = 20;
    private int nSamples = nSampleRate / nPackages;
    int widthPlane = 800;
    int heightPlane = 600;
    int baseY = 0;  
    
    // larghezza piano cartesiano
    int widthX = widthPlane - 100;
    int heighY = 0;
    
    // scala campioni    
    int widthScalaCampione = 0;
    int heightScalaCampione = 0;
    
    int xUnit = 0;
    
    java.util.Vector vValori = null;

    public volatile boolean isTerminated = false;
    
    public Spectrum (int _nPackages, int _nSampleRate){

        nSampleRate = _nSampleRate; //8192;// 10240; //16384; //32768; // 43008;
        nPackages = _nPackages;
        nSamples = nSampleRate / nPackages;

        vValori = new java.util.Vector();
    }


    public void executeTest(float testFrequence, int numBytes, int nSampleRate, int freqMin, int freqAmplitude, int nPackage, int nDimension, javax.swing.JTextField semaforo_jTextField){
        Sampler sampler = new Sampler();
        //sampler.setup();


        nPackages = nPackage;
        nSamples = nSampleRate / nPackages;
        
        try{
            MetaTagAudio samplerAudio = sampler.execute(testFrequence, freqMin, freqAmplitude, numBytes, nSampleRate, nPackages, nPackage, nDimension, semaforo_jTextField);

            String sequenceHMM = samplerAudio.stateHMM_ToString();
            System.out.println("Sequenza: " + sequenceHMM + "\n");

            clearAll(this.getGraphics());

            setDataVector(samplerAudio);

            repaint();
        }
        catch(Exception ex){
            System.err.println(ex.getMessage());
        }
        sampler = null;
    }


    /**
     * Exec sampler voice
     *
     * @param word
     * @param state
     * @param isTraining
     */
    public void executeSampler(String word, int state, int freqMin, int freqAmpliMin, int nSampleRate, int _nPackages, int maxPackages, int nDimension, boolean isTraining, javax.swing.JTextField semaforo_jTextField){
        int nDimensions = 1;
        int nSeq = 10;        

        Sampler sampler = new Sampler();
        sampler.setup();

        nPackages = _nPackages;
        nSamples = nSampleRate / nPackages;

        while(!isTerminated){
            MetaTagAudio samplerAudio = sampler.execute(word, freqMin, freqAmpliMin, nSampleRate, nPackages, maxPackages, nDimension, semaforo_jTextField);
            try{

                String sequenceHMM = samplerAudio.stateHMM_ToString();
                System.out.println("Sequenza: " + sequenceHMM + "\n");

                if(isTraining){
                    //For training
                    String fileTraining = word + ".training";
                    
                    HMM_Manager.addSequenceTraining(fileTraining, sequenceHMM, nDimensions, nSeq, nPackages);
                }
                else{
                    // for match
                    String fileHMM = word + ".hmm";
                    HMM hmm = HMM.load(fileHMM);

                    double[][] seq = new double[nPackages][nDimensions * 2];
                    for(int i=0; i< nPackages; i++){
                        int j=0;
                        while(j<nDimensions){
                            seq[i][j] = samplerAudio.stateHMM[i][j];
                        }
                    }
                    double perc = HMM_Manager.getProbability(hmm, nDimensions, nPackages, seq);

                    System.out.println("\nPercentuale di riconoscimento: " + perc + " %\n");
                }
            }
            catch(Exception ex){
                System.err.println(ex.getMessage());
            }

            clearAll(this.getGraphics());

            setDataVector(samplerAudio);

            repaint();
        }

        sampler = null;
    }


    public void paintSampler(MetaTagAudio samplerAudio){
        clearAll(this.getGraphics());

        setDataVector(samplerAudio);

        repaint();
    }
    
    /**
     * Creazione del piano cartesiano
     *
     **/    
    private void createPlane(Graphics g){
        x0 = 40;
        y0 = 20;

        widthPlane = getSize().width;
        heightPlane = getSize().height;
     
        heighY = heightPlane -10;
        widthX = widthPlane - 10 - x0;

        baseY = heighY / 4;
        // colori base
        g.setColor(Color.BLACK);
        g.fillRect(0,0,widthPlane,heightPlane);
        g.setColor(Color.RED);
               
        // ascisse
        g.drawLine(x0, baseY, widthX + x0, baseY);
        
        // freccia ascisse
        g.drawLine(widthX + x0, baseY, widthX + x0 - 10, baseY - 5);
        g.drawLine(widthX + x0, baseY, widthX + x0 - 10, baseY + 5);
        
        // ordinate
        g.drawLine(x0, y0, x0, heighY);
    
        // freccia ordinate
        g.drawLine(x0, y0, x0 -5, y0 + 5);
        g.drawLine(x0, y0, x0 + 5, y0 + 5);
        
        // Stringhe
        FontMetrics metrics = g.getFontMetrics();
        
        String textAmpiezza = "ampiezza";
        g.drawString(textAmpiezza, x0, y0 - 5);

        if(widthPlane > 400 && heightPlane > 300){
            g.drawString("Pacchetti: "+ String.valueOf(nPackages), widthPlane - 250, (baseY * 3));
        }
        
        if(widthPlane > 300 && heightPlane > 300){
            String textSamples = padLeft("Dimensione pacchetti : " + nSamples, 30);
            g.drawString(textSamples, widthPlane - 180, (baseY * 3));
        }

        if(widthPlane > 400 && heightPlane > 400){
            String textSampleRate = padLeft("Frequenza campionamento : " + nSampleRate, 32);
            g.drawString(textSampleRate, widthPlane - 250, (baseY * 3) + 20);
        }

    }
    
    
    private void setScale(Graphics g){     

        int nStepY = 11;

        // scala campioni
        widthScalaCampione = widthX / nPackages;
        heightScalaCampione = ((baseY - 20) / 10);
        
        boolean up = true;
        // ascisse
        for(int i=1; i <= nPackages; i++){
            int valueX = i * widthScalaCampione;
            int x = x0 + valueX;
            String textIndex = String.valueOf(i * nSamples);

            if(up){
                g.drawLine(x, baseY -3, x, baseY + 3);
                g.drawString(textIndex, x - (textIndex.length() * 3) ,  baseY + 20);
                up = false;
            }
            else{
                g.drawLine(x, baseY -3, x, baseY + 23);
                g.drawString(textIndex, x - (textIndex.length() * 3) ,  baseY + 40);
                up = true;
            }
        }

        // ordinate segnale
        // scala valori positivi
        for(int j=0; j < nStepY; j++){
            int y = j * heightScalaCampione ;            
            if(y > 0){
                g.drawLine(x0 -3, baseY - y, x0 +3, baseY - y);
                g.drawString(padLeft(String.valueOf(j * 10), 3), x0 -30,  baseY - y + 5);
            }                        
        }

        // scala valori negativi segnale
        for(int j=0; j < nStepY; j++){
            int y = j * heightScalaCampione ;
            
            g.drawLine(x0 -3, baseY + y, x0 +3, baseY + y);
            if (y> 0){
                g.drawString(padLeft("-" + String.valueOf(j * 10), 4), x0 -35,  baseY + y + 5);
            }             
        } 

        
        // linea dei pacchetti FFT
        up = true;
        for(int nP=0; nP <= (nPackages / 2); nP++){
            int valueXP = nP * widthScalaCampione;
            int xP = x0 + valueXP;            
            if(nP > 0){
                // suddivisione grafico in packages                
                if(up){
                    g.drawString(String.valueOf(nSamples * nP), xP-10, (heighY - 50) + 20);
                    g.drawLine(xP, baseY + (heightScalaCampione * 10), xP, heighY - 50);
                    up = false;
                }
                else{
                    g.drawLine(xP, baseY + (heightScalaCampione * 10), xP, heighY - 30);
                    g.drawString(String.valueOf(nSamples * nP), xP-10, (heighY - 50) + 40);
                    up = true;
                }
                
            }
        }            
    }
    

    public void stopSampler(){
        isTerminated = true;
    }

    /**
     * 
     * @param samplerMetaAudio
     */
    public void setDataVector(MetaTagAudio samplerMetaAudio){
        vValori.add(samplerMetaAudio);
    }
    
    

    public java.util.Vector getSignalsVector(){

        if(vValori != null){
            // scrittura dati segnali
            return vValori;
        }
        else{
            return new java.util.Vector();
        }
    }
    
    
    public void paintComponent(Graphics g) {
        
        int scala = 1;       
                      
        createPlane(g);
      
        setScale(g);

        try{
            scala = nSampleRate / (widthScalaCampione * nPackages);
            //scala = ;
        }
        catch(Exception ex){}
        
        java.util.Vector vValori = getSignalsVector();

        Graphics2D g2 = (Graphics2D)g;
        float nScale = Float.valueOf(1) / Float.valueOf(scala);
        x0 = x0 * scala;
           
        for(int i = 0; i < vValori.size(); i++){
            MetaTagAudio samplerAudio = (MetaTagAudio)vValori.get(i);
            float[] signal = samplerAudio.WordByte;

            if(signal != null){
                g2.scale(nScale, 1.0);
                drawSignal(g2,  getColor(i), signal);        
                              
                // scrittura packages
                int x = 0;             
                
                for(int k=0; k < samplerAudio.NumPackages; k++){
                    try{
                        // ricomposizione dei pacchetti del seganle
                        //float[] _signal = (float[])samplerAudio.SignalPackages.get(k);
                        int newX = (x + ((nSamples - 1) * k) );
                        //drawPackageSignal(g2,  getColor(i), _signal, newX);

                        // frequence ; amplietude
                        float[][] seqSpectrm = (float[][])samplerAudio.FFTPackages.get(k);
                        drawPackageSpectrum(g2, seqSpectrm, newX, k);
                    }
                    catch(Exception ex){
                        //System.out.println("WARNING: Valori non corretti per package: " + (k+1));
                    }
                }                 
            }            
        }        
    }

    
    private Color getColor(int n){

        if (n < 0){
            n = n * - 1;
        }
                
        if((n > 0) && (n < 31)){
            return Color.WHITE;
        }
                       
        if((n > 30) && (n < 61)){
            return Color.LIGHT_GRAY;
        }
        
        if((n > 60) && (n < 91)) {
            return Color.DARK_GRAY;
        }

        if((n > 90) && (n < 121)){
            return Color.GREEN;
        }

        if((n > 120) && (n < 151)){
            return Color.CYAN;
        }
        
        if((n > 150) && (n < 181)){
            return Color.BLUE;
        }
        
        if((n > 180) && (n < 221)){
            return Color.ORANGE;
        }

        if((n > 220) && (n < 251)){
            return Color.YELLOW;
        }

        if((n > 250) && (n < 251)){
            return Color.MAGENTA;
        }        
        
        return Color.WHITE;
    }
    

    
    /**
     *
     * @param g2
     * @param g
     * @param color
     * @param spectrum
     * @param x
     */
    public void drawPackageSpectrum(Graphics2D g2, float[][] seqSpectrum, int offset, int nPackage){

        int plusY = ((heighY - (baseY * 3)) / nPackages) * (nPackage);
        int y_1 = (baseY * 2) + (heightScalaCampione * 10) + plusY;

        g2.setColor(Color.RED);
        g2.drawLine(x0 - 10, y_1 , x0 + 10, y_1);

        for(int i=0; i < seqSpectrum.length; i++){
            
            // frequenza
            int frequenceValue =  Math.round(seqSpectrum[i][0]);
            // ampiezza
            int frequenceAmpl =  Math.round(seqSpectrum[i][1]);

            if(frequenceAmpl > 0){
                g2.setColor(getColor(frequenceValue));
                // imposto nuovi valori
                int x_1 = x0 + frequenceValue;
                g2.drawLine(x_1, y_1 , x_1, (y_1 - frequenceAmpl));
            }
        }
    }    
    
    
    public void drawSignal(Graphics2D g2, Color color, float[] signal){
        g2.setColor(color);        
        int x_1 = x0;
        int y_1 = baseY;
        int x_2 = x0;
        int y_2 = baseY;
        
        
        for(int i=0; i < signal.length; i++){
            // valore
            int value = Math.round(signal[i] * 100);
            
            g2.setColor(getColor(value));
            
            // imposto nuovi valori
            x_2 = x0 + i;
            y_2 = baseY + (value * -1);
            
            // scrivo riga
            g2.drawLine(x_1, y_1, x_2, y_2);
                        
            // imposto vecchi valori
            x_1 = x_2;
            y_1 = y_2;
        }
    }
    
    
    public void drawPackageSignal(Graphics2D g2, Color color, float[] signal, int x){
        g2.setColor(color);  
        int plusY = 220;
        int x_1 = x0 +x;
        int y_1 = baseY + plusY;
        int x_2 = x0 +x;
        int y_2 = baseY + plusY;
        
        
        for(int i=0; i < signal.length; i++){
            // valore
            int value = Math.round(signal[i] * 100);
            
            g2.setColor(getColor(value));
            
            // imposto nuovi valori
            x_2 = x0 + i + x;
            y_2 = baseY + (value * -1) + plusY;
            
            // scrivo riga
            if(i>0){
                g2.drawLine(x_1, y_1, x_2, y_2);
            }
            
                        
            // imposto vecchi valori
            x_1 = x_2;
            y_1 = y_2;
        }
    }
    
    
   private String padLeft(String parmString, int parmLen){
        String tempString = parmString;
        if (tempString.length() > parmLen){
            tempString = tempString.substring(tempString.length()-parmLen,
            tempString.length());
        }
        else{
            while (tempString.length() < parmLen)
            tempString = " "+tempString;
        }
        return tempString;  
  } 
    
    
   public void clearAll(Graphics g){
       
        createPlane(g);
        
        setScale(g);
        
        vValori.clear();
        
        repaint();
   }
   
     
    public static void main(String argv[]) {
        JFrame f = new JFrame("Signal Spectrum");
        
        f.addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent winEvt) {
                System.exit(0); 
            }
        });

        f.setSize(1200,750);
        Spectrum spectrum = new Spectrum(1024, 40);
        f.getContentPane().add(spectrum);
        f.setVisible(true);

        /*
         * @param word
         * @param state
         * @param isTraining
         */
        spectrum.executeSampler("ciao", 516, 300, 3, 10240, 20, 20, 1, true, new javax.swing.JTextField());
    }
}


 
    